#! /bin/sh
#
# Copyright (C) 2000, by Powerware.  All rights reserved.
#
# This agent.sh script installs LanSafe for SNMP files PowerMonitorAgent and rfc1628.defs into
# the same directory where PowerMonitor for Unix is installed.
#
# PowerMonitor Agent file is the LanSafe SNMP Agent executable. It requires PowerMonitor 
# daemon to be running in order to work.
#
# rfc1628.defs file has RFC1628 MIB settings. PowerMonitorAgent uses this file.
#
# On AIX4 and AIX5 it modifies or creates files:
#	/etc/snmpd.conf
#	/etc/snmpd.peers
#	/etc/mib.defs
#	/etc/inittab
#
# On HP-UX 9.x it modifies or creates files:
#	/etc/snmpd.extend
#	/etc/inittab
#
# On HP-UX 10.x and 11.x it modifies or creates files:
#	/etc/SnmpAgent.d/snmp.extend
#	/sbin/init.d/lsagent.init
#	/sbin/rc2.d/S760lsagent.init
#	/sbin/rc1.d/K485lsagent.init
#
# On SCO5 it modifies or creates files:
#	/etc/snmpd.peers
#	/etc/init.d/lsagent.init
#	/etc/rc2.d/S89lsagent.init
#	/etc/rc0.d/K99lsagent.init
#
# On Solaris 2.x it modifies or creates files:
#	/etc/SnmpAgent.d/snmpd.extend
#	/etc/init.d/lsagent.init
#	/etc/rc2.d/S99lsagent.init
#	/etc/rc0.d/K99lsagent.init
#
# On UnixWare2 it modifies or creates files:
#	/etc/netmgmt/snmpd.peers
#	/etc/init.d/lsagent.init
#	/etc/rc2.d/S89lsagent.init
#	/etc/rc0.d/K99lsagent.init

PATH=$PATH:/bin:/usr/bin:/usr/ucb:.; export PATH

initDefines() {
DGUX_SYS_ERROR=1
ERR_UNKNOWN_SYS_STR1=2
ERR_UNKNOWN_SYS_STR2=3
ERR_UNKNOWN_SYS_STR3=4
ERR_CHECK_FATAL_OVERRIDE=5
ERR_CHECK_FATAL_EXIT=6
ERR_CHECK_STATUS=7
INSTALL_FROM=8
INSTALL_TO=9
INSTALLED_STR=10
INSTALLED_DONE=11
GET_DEVICE_NAME=12
INSTALL_DEVICE=13
ERR_INVALID_DIR=14
ERR_INVALID_DEVICE_STR1=15
ERR_INVALID_DEVICE_STR2=16
OK_STR=17
ERR_NO_DEVICE=18
EXTRACTING_FILE=19
ERR_EXTRACTING_FILE=20
UPS_DRIVER_STR1=21
UPS_DRIVER_STR2=22
UPS_DRIVER_STR3=23
UW2_UPS_DRIVER_STR1=24
UW2_UPS_DRIVER_STR2=25
UW2_UPS_DRIVER_STR3=26
UW2_UPS_DRIVER_STR4=27
UW2_UPS_DRIVER_STR5=28
UW2_UPS_DRIVER_STR6=29
UW2_UPS_DRIVER_STR7=30
UW2_UPS_DRIVER_STR8=31
IA_UPS_DRIVER_STR1=32
IA_UPS_DRIVER_STR2=33
IA_UPS_DRIVER_STR3=34
IA_UPS_DRIVER_STR4=35
IA_UPS_DRIVER_STR5=36
IA_UPS_DRIVER_STR6=37
IA_UPS_DRIVER_STR7=38
IA_UPS_DRIVER_STR8=39
GENERAL_UPS_DRIVER_STR1=40
GENERAL_UPS_DRIVER_STR2=41
GENERAL_UPS_DRIVER_STR3=42
ASK_INSTALL_DEVICE_DRV=43
NO_INSTALL_DRV_STR1=44
NO_INSTALL_DRV_STR2=45
NO_INSTALL_DRV_STR3=46
ERR_SERVICES_FILE_STR1=47
ERR_SERVICES_FILE_STR2=48
ERR_SERVICES_FILE_STR3=49
ADDING_LS_SERVICE=50
MODIFIED_SERVICES=51
REMOVE_SERVICE_STR=52
ADD_SERVICE_STR=53
PM_DESCRIPTION=54
REMOVED_STR=55
COPY_INIT_FILE=56
INSTALLING_INIT_FILE=57
INSTALLED_STR=58
DELETING_FILE_STR=59
LINK_FILE_STR=60
LINKED_STR=61
WELCOME_STR1=62
WELCOME_STR2=63
WELCOME_STR3=64
CONTINUE_INSTALLATION=65
INSTALL_INTRO_STR1=66
INSTALL_INTRO_STR2=67
INSTALL_INTRO_STR3=68
INSTALL_INTRO_STR4=69
INSTALL_INTRO_STR5=70
INSTALL_INTRO_STR6=71
INSTALL_INTRO_STR7=72
INSTALL_INTRO_STR8=73
AGENT_INSTALL_INTRO_STR1=74
AGENT_INSTALL_INTRO_STR2=75
AGENT_INSTALL_INTRO_STR3=76
AGENT_INSTALL_INTRO_STR4=77
AGENT_INSTALL_INTRO_STR5=78
AGENT_INSTALL_INTRO_STR6=79
AGENT_INSTALL_INTRO_STR7=80
ERR_UNKNOWN_SYSTEM=81
SVR4_AGENT_INSTALL_STR1=82
SVR4_AGENT_INSTALL_STR2=83
INSTALL_SOURCE_CDROM=84
INSTALL_SOURCE_TARFILE=85
DEFAULT_PATH_STR=86
ASK_CHANGE_INSTALL_PATH=87
ENTER_INSTALL_PATH=88
NEW_PATH=89
ERR_INSTALL_PATH=90
ERR_AGENT_INSTALL_PATH_STR1=91
ERR_AGENT_INSTALL_PATH_STR2=92
AUTO_START_STR1=93
AUTO_START_STR2=94
AUTO_START_STR3=95
AUTO_START_STR4=96
AUTO_START_STR5=97
AUTO_START_STR6=98
CONFIRM_INSTALL_PARAMS_STR1=99
CONFIRM_INSTALL_PARAMS_STR2=100
CONFIRM_INSTALL_PARAMS_STR3=101
CONFIRM_INSTALL_PARAMS_STR4=102
CONFIRM_INSTALL_PARAMS_STR5=103
LICENSE_AGREEMENT=104
ERR_LIC_AGREE=105
ERR_AUTO_LOAD_STR1=106
ERR_AUTO_LOAD_STR2=107
ERR_AUTO_LOAD_STR3=108
CONFIRM_OK=109
ERR_UW2_DRY_CONTACT_UPS=110
EXTRACT_AGENT_WAIT=111
ERR_EXTRACT_AGENT=112
ERR_LINK_HPUX_STR1=113
ERR_LINK_HPUX_STR2=114
ERR_LINK_HPUX_STR3=115
ERR_LINK_HPUX_STR4=116
ERR_LINK_HPUX_STR5=117
PRESS_CONTINUE=118
ERR_LINK_SUNOS_STR1=119
ERR_LINK_SUNOS_STR2=120
ERR_LINK_SUNOS_STR3=121
ERR_LINK_SUNOS_STR4=122
ERR_LINK_SUNOS_STR5=123
ERR_LINK_SUNOS_STR6=124
ERR_LINK_SUNOS_STR7=125
ERR_LINK_SUNOS_STR8=126
SUCCESS_INSTALLED_LS=127
REGISTRATION_STR1=128
REGISTRATION_STR2=129
WARN_WEB_BROWSER=130
UNSUCCESS_INSTALLED_LS=131
ERR_UNKNOWN_SYS_STR4=132
REFRESH_SNMP=133
MIB_MODIFY_STR1=134
MIB_MODIFY_STR2=135
ERR_HPUX_PATCH=136
HPUX_EXT_AGENT_GOOD=137
ERR_NORUN_HPUX_EXT_AGENT_STR1=138
ERR_NORUN_HPUX_EXT_AGENT_STR2=139
ERR_NORUN_HPUX_EXT_AGENT_STR3=140
ERR_NORUN_HPUX_EXT_AGENT_STR4=141
ERR_NO_EXIST_HPUX_EXT_AGENT_STR1=142
ERR_NO_EXIST_HPUX_EXT_AGENT_STR2=143
ERR_NO_EXIST_HPUX_EXT_AGENT_STR3=144
ERR_NO_EXIST_HPUX_EXT_AGENT_STR4=145
WARN_HPUX_MODIFY_EXTFILE_STR1=146
WARN_HPUX_MODIFY_EXTFILE_STR2=147
ERR_HPUX_TRAP_STR1=148
ERR_HPUX_TRAP_STR2=149
SOL_EXT_AGENT_GOOD=150
ERR_NORUN_SOL_EXT_AGENT_STR1=151
ERR_NORUN_SOL_EXT_AGENT_STR2=152
ERR_NORUN_SOL_EXT_AGENT_STR3=153
ERR_NORUN_SOL_EXT_AGENT_STR4=154
ERR_NO_EXIST_SOL_EXT_AGENT_STR1=155
ERR_NO_EXIST_SOL_EXT_AGENT_STR2=156
ERR_NO_EXIST_SOL_EXT_AGENT_STR3=157
ERR_NO_EXIST_SOL_EXT_AGENT_STR4=158
ERR_SOL_SNMP_TRAP_STR1=159
ERR_SOL_SNMP_TRAP_STR2=160
ERR_SOL_SNMP_TRAP_STR3=161
ERR_SOL_SNMP_TRAP_STR4=162
ERR_SOL_SNMP_TRAP_STR5=163
PM_RUNNING=164
WARN_PM_NOT_RUN_STR1=165
WARN_PM_NOT_RUN_STR2=166
WARN_PM_NOT_RUN_STR3=167
WARN_PM_NOT_RUN_STR4=168
WARN_PM_NOT_RUN_STR5=169
AUTO_START_AGENT_STR1=170
AUTO_START_AGENT_STR2=171
AUTO_START_AGENT_STR3=172
AGENT_PARAMS_TO_STR1=173
AGENT_PARAMS_TO_STR2=174
AGENT_PARAMS_TO_STR3=175
AGENT_PARAMS_TO_STR4=176
AGENT_CUSTOM_PATH_STR1=177
AGENT_CUSTOM_PATH_STR2=178
ERR_NO_PM_EXE=179
ERR_ABS_PATH=180
ERR_AGENT_SYS_STR1=181
ERR_AGENT_SYS_STR2=182
ERR_NOT_DEVICE_NAME=183
ERR_NO_DIR=184
AGENT_WELCOME_STR1=185
AGENT_WELCOME_STR2=186
AGENT_WELCOME_STR3=187
AGENT_WELCOME_STR4=188
AGENT_WELCOME_STR5=189
AGENT_WELCOME_STR6=190
AGENT_WELCOME_STR7=191
AGENT_WELCOME_STR8=192
SNMP_DEAMON_RUNNING=193
ERR_SNMP_DEAMON_NOT_RUN_STR1=194
ERR_SNMP_DEAMON_NOT_RUN_STR2=195
ERR_SNMP_DEAMON_NOT_RUN_STR3=196
ERR_SNMP_DEAMON_NOT_RUN_STR4=197
ERR_SNMP_DEAMON_NOT_RUN_STR5=198
AGENT_SAME_DIR_STR1=199
AGENT_SAME_DIR_STR2=200
AGENT_FOUND_DEF_PATH_STR1=201
AGENT_FOUND_DEF_PATH_STR2=202
WARN_NO_DEF_PATH_STR1=203
WARN_NO_DEF_PATH_STR2=204
AGENT_CUSTOM_PATH=205
AGENT_SUCCESS_INSTALLED=206
ERR_INVALID_ARGUMENTS=207
AGENT_USAGE_STR=208
USAGE_STR=209
REGISTER_WEBSITE=210

}

compute_files () {
if [ $system = "aix" -o $SYSTEM = "AIX" ]; then
cat <<EOF
PowerMonitorAgent
rfc1628.no_mw
rfc1628.mwise
rfc1628.defs
EOF
fi
if [ $system = "sco" -o $SYSTEM = "SCO" ]; then
cat <<EOF
PowerMonitorAgent
rfc1628.no_mw
rfc1628.mwise
rfc1628.defs
EOF
fi
if [ $system = "hpux" -o $SYSTEM = "HPUX" ]; then
cat <<EOF
PowerMonitorAgent
rfc1628.no_mw
rfc1628.mwise
snmpd.extend.v3
snmpd.extend.v4
EOF
fi
if [ $system = "uw2" -o $SYSTEM = "UW2" ]; then
cat <<EOF
PowerMonitorAgent
rfc1628.no_mw
rfc1628.mwise
rfc1628.defs
EOF
fi
if [ $system = "solari" -o $SYSTEM = "SOLARI" ]; then
cat <<EOF
PowerMonitorAgent
rfc1628.no_mw
rfc1628.mwise
snmpd.extend.v4
EOF
fi
}

Convert_Case () {
	if [ -f ./INSTALL.SH ]; then
		echo `Convert_UpperCase $1`
	else
		echo `Convert_LowerCase $1`
	fi
}

Convert_Name() {
    case $1 in
	PowerMonitorAgent)
	    echo PowerMonitorAgent
	;;
	rfc1628.xmw)
	    echo rfc1628.xmw
	;;
	snmpdext.v3)
	    echo snmpdext.v3
	;;
	snmpdext.v4)
	    echo snmpdext.v4
	;;
	snmpd.extend.v4)
	    echo snmpd.extend.v4
	;;
	snmpd.extend.v3)
	    echo snmpd.extend.v3
	;;
	rfc1628.defs)
	    echo rfc1628.defs
	;;
	rfc1628.mib)
	    echo rfc1628.mib
	;;
	rfc1628.no_mw)
	    echo rfc1628.xmw
	;;
	rfc1628.mwise)
	    echo rfc1628.mib
	;;
    esac
}

compute_disks () {
	echo  1 2
}

compute_SYSTEM () {
	set `uname -a`
}

Convert_UpperCase () {
    case $1 in
	PowerMonitorAgent)
	    echo POWERMONITORAGENT
	;;
	rfc1628.xmw)
	    echo RFC1628.XMW
	;;
	snmpdext.v3)
	    echo SNMPDEXT.V3
	;;
	snmpdext.v4)
	    echo SNMPDEXT.V4
	;;
	snmpd.extend.v4)
	    echo SNMPD.EXTEND.V4
	;;
	snmpd.extend.v3)
	    echo SNMPD.EXTEND.V3
	;;
	rfc1628.defs)
	    echo RFC1628.DEF
	;;
	rfc1628.mib)
	    echo RFC1628.MIB
	;;
	rfc1628.no_mw)
	    echo RFC1628.XMW
	;;
	rfc1628.mwise)
	    echo RFC1628.MIB
	;;
    esac
}

Convert_LowerCase () {
    case $1 in
	PowerMonitorAgent)
	    echo powermonitoragent
	;;
	rfc1628.xmw)
	    echo rfc1628.xmw
	;;
	snmpdext.v3)
	    echo snmpdext.v3
	;;
	snmpdext.v4)
	    echo snmpdext.v4
	;;
	snmpd.extend.v4)
	    echo snmpd.extend.v4
	;;
	snmpd.extend.v3)
	    echo snmpd.extend.v3
	;;
	rfc1628.defs)
	    echo rfc1628.defs
	;;
	rfc1628.mib)
	    echo rfc1628.mib
	;;
	rfc1628.no_mw)
	    echo rfc1628.xmw
	;;
	rfc1628.mwise)
	    echo rfc1628.mib
	;;
    esac
}

compute_disks () {
	echo  1 2
}

compute_SYSTEM () {
	set `uname -a`
	case $1 in
	Linux)
		SYSTEM=LINUX
		;;
	SunOS)
		case $3 in
		5.*)
			case $5 in
			i86pc)
				SYSTEM=SOLINT
				;;
			*)
				SYSTEM=SOLARI
				;;
			esac
		;;
		*)
			SYSTEM=SUNOS
			;;
		esac
		;;
	HP-UX)
		SYSTEM=HPUX
		;;
	OSF1)
		SYSTEM=DEC
		;;
	dgux)
		SYSTEM=DGUX
		;;
	SCO_SV)
		SYSTEM=SCO
		;;
	UnixWare)
		SYSTEM=UW2
		;;
	UNIX_SV)
		if [ -f /etc/issue ]; then
			grep "UnixWare" /etc/issue >/dev/null 2>/dev/null
			if [ $? != 1 ]; then
				SYSTEM=UW2
			else
				SYSTEM=SVR4
			fi
		else
			SYSTEM=SVR4
		fi
		;;
	AIX)
		case $4 in
		3)
			SYSTEM=AIX3
			;;
		4)
			SYSTEM=AIX
			;;
		5)
			SYSTEM=AIX
			;;
		esac
		;;
	*)
		if [ -c /dev/tty1A ]; then
			SYSTEM=SCO
		elif [ -c /dev/ttyd0 -a "$1" != "Linux" ]; then
			SYSTEM=IA
		elif [ -c /dev/ttypa -a "$1" != "Linux" ]; then
			SYSTEM=IA
		else
			SYSTEM="Unknown System"
		fi
		;;
	esac
}

compute_system () {
	case $SYSTEM in
	LINUX)
		system=linux
		;;
	SOLINT)
		system=solint
		;;
	SOLARI)
		system=solari
		;;
	SUNOS)
		system=sunos
		;;
	HPUX)
		system=hpux
		;;
	DEC)
		system=dec
		;;
	DGUX)
		system=dgux
		;;
	SCO)
		system=sco
		;;
	UW2)
		system=uw2
		;;
	SVR4)
		system=svr4
		;;
	AIX3)
		system=aix3
		;;
	AIX)
		system=aix
		;;
#  From LanSafe 5.0.0.0, system is set to aix for both AIX4 and AIX5
	AIX5)
		system=aix
		;;
	IA)
		system=ia
		;;
	"Unknown System")
		system="Unknown System"
		;;
	*)
		echo
		echo Unknown System \"$SYSTEM\". LanSafe installation can not continue.
		echo Please specify your system like, "\"./install.sh <SYSTEM>\""
		echo Valid systems are LINUX SOLINT SOLARI SUNOS HPUX DEC DGUX SCO UW2 SVR4 AIX4 AIX5 IA

        lineStr=`head -$ERR_UNKNOWN_SYS_STR1 $INSTALLRES |tail -1`
        lineStr1=`head -$ERR_UNKNOWN_SYS_STR4 $INSTALLRES |tail -1`
        echo "$lineStr \"$SYSTEM\". $lineStr1"
        lineStr=`head -$ERR_UNKNOWN_SYS_STR2 $INSTALLRES |tail -1`
        echo $lineStr
        lineStr=`head -$ERR_UNKNOWN_SYS_STR3 $INSTALLRES |tail -1`
        echo $lineStr

		echo
		exit
		;;
	esac
}

compute_sco_system () {
	set `uname -a`
	case $1 in
	SCO_SV)
		echo sco5
		;;
	*)
		echo sco3
		;;
	esac
}

compute_uncompress () {
    for subdir in `compute_tapedirs`; do
	if [ -f $subdir/gunzip ]; then
	    echo $subdir/gunzip
	    return
	fi
    done
    if [ -f gunzip ]; then
	echo gunzip
    fi
    echo uncompress
}

untar_to () {
    name=$1
    dst=$2
    perm=$3
    prefix=.
    for subdir in `compute_tapedirs`; do
	if [ -f $subdir/$name ]; then
	    prefix=$subdir
	fi
	if [ -f $subdir/$name.z ]; then
	    prefix=$subdir
	fi
	if [ -f $subdir/$name.Z ]; then
	    prefix=$subdir
	fi
    done
    src=$prefix/$name

    create_path $dst
    check_fatal

    if [ ! -f $src ]; then
	if [ -f $src.z ]; then
	    $uncompress_cmd $src.z
	    check_fatal
	fi
	if [ -f $src.Z ]; then
	    $uncompress_cmd $src.Z
	    check_fatal
	fi
    fi

    if [ -f $dst/$name ]; then
	mv -f $dst/$name $dst/$name~ > /dev/null 2>&1
    fi

    mv -f $src $dst >/dev/null 2>&1
    if [ $? != 0 ]; then
        cp $src $dst
	check_fatal
	rm -f $src
    fi

	lineStr=`head -$INSTALL_FROM $INSTALLRES |tail -1`
	lineStr1=`head -$INSTALL_TO $INSTALLRES |tail -1`
	lineStr2=`head -$INSTALLED_DONE $INSTALLRES |tail -1`

    chmod $perm $dst/$name
#    (cd $dst; tar -xvf $name |
#     awk '{ print "Installing " $2 " to '$dst' ... done" }' |
#     sed 's/, / /' ) 2>/dev/null
	(cd $dst; tar -xvf $name |
	awk '{ print "$lineStr " $2 " $lineStr1 '$dst' ... $lineStr2" }' |
	sed 's/, / /' ) 2>/dev/null
    check_fatal
    for f in `(cd $dst; tar -tf $name 2>/dev/null)`; do
	echo "Installed: $dst/$f" >> $instpath/Bin/installed.snmp
	chmod $perm $dst/$f
	check_fatal
	chown bin $dst/$f
	chgrp bin $dst/$f
    done
    rm -f $dst/$name
}

compute_echo () {
    if [ `echo "\c" | wc -l` = 1 ]; then
        echo true
    else
        echo ""
    fi
}

echo_n () {
    if [ $bsdecho ]; then
        echo -n "$*"
    else
        echo "$*\c"
    fi
}


check_fatal () {
    if [ $? != 0 ]; then
        if [ $override ]; then
#            echo "Install failed.  Override set."
			lineStr=`head -$ERR_CHECK_FATAL_OVERRIDE $INSTALLRES |tail -1`
			echo $lineStr
            return 0
        fi
#        echo "Install failed.  Exiting"
		lineStr=`head -$ERR_CHECK_FATAL_EXIT $INSTALLRES |tail -1`
		echo $lineStr
        exit 1
    fi
}

check_status () {
    if [ $? != 0 ]; then
        if [ $override ]; then
#            echo "Check status failed.  Override set."
			lineStr=`head -$ERR_CHECK_STATUS $INSTALLRES |tail -1`
			echo $lineStr
            return 0
        fi
        return 1
    fi
    return 0
}

read_def () {
    prompt=$1
    default=$2

    echo_n "$prompt"
    read answer
    if [ -z "$answer" ]; then
        answer=$default
    fi
}

kill_ls3agent () {
        pidargs=-ax                     # BSD sunos
        ps -ax > /dev/null 2>&1
        if [ $? != "0" ]; then
                pidargs=-e              # svr3 svr4
        fi
        pids=`ps $pidargs | awk '/PowerMonitorAgent/ { print $1 }'`
        kill -9 $pids > /dev/null 2>&1
}

# AIX specific procedures start here
aix_check_netview () {

 ps -eo command | awk '{ if ($1 == "ovw_binary" ) exit 1 }'
   if [ $? = 1 ] ; then
       # NetView GUI is running
       netview_running=true
   else
       # NetView GUI is not running
       netview_running=
  fi

}

aix_refresh_netview () {

if [ -n "$snmpd_running" ]; then
#    echo "Refreshing SNMP subsystem..."
    lineStr=`head -$REFRESH_SNMP $INSTALLRES |tail -1`
    echo "$lineStr"
    /usr/bin/refresh -s snmpd
fi

}

aix_check_snmpd () {

ps -eo command | awk '{ if ($1 == "snmpd" ) exit 1 }'
   if [ $? = 1 ] ; then
       # SNMP daemon is running
       snmpd_running=true
   else
       # SNMP daemon is not running
       snmpd_running=
  fi
}

aix_check_sysmand () {

ps -eo command | awk '{ if ($1 == "sysmand" ) exit 1 }'
   if [ $? = 1 ] ; then
       # sysmand daemon is running
       sysmand_running=true
   else
       # sysmand daemon is not running
       sysmand_running=
  fi
}

aix_get_community_name () {

   ovbinroot=/usr/OV/bin

   if [ ! -f $ovbinroot/xnmsnmpconf ]; then
      	community_name=private
   else
        # Try first with hostname
        $ovbinroot/xnmsnmpconf -read $this_node_name > /dev/null 2>&1
        if [ $? = 0 ]; then
            # If it fails try with *.*.*.*
            community_name=`$ovbinroot/xnmsnmpconf -read \*.\*.\*.\* | awk -F: '{ print $8 }'`
            check_fatal
        else
            community_name=`$ovbinroot/xnmsnmpconf -read $this_node_name | awk -F: '{ print $8 }'`
            check_fatal
        fi
   fi
}

aix_check_systems_monitor () {

# This checks if lines
# Systems Monitor (SLM) is installed, trap destinations should be configured via the SLM's trap destination table - NOT IN THIS FILE
# exists in /etc/snmpd.conf file
    snmpd_conf=/etc/snmpd.conf

grep ^"# Systems Monitor (SLM)" $snmpd_conf 2>/dev/null

if [ $? = 0 ]; then
     # Found the first line
     grep ^"# configured via the SLM" $snmpd_conf
     if [ $? = 0 ]; then
            # Found second line.
       	    SLM_installed=true
     else
	    # Found ONLY one line.
	    # Assuming false.
            SLM_installed=""
	      fi
else
    # Did not find any lines.
    SLM_installed=""
fi

}

aix_setup_snmpd_conf () {
    snmpd_conf=/etc/snmpd.conf
    # Backup old snmpd.conf
    cp $snmpd_conf ${snmpd_conf}.ls.$$
    check_fatal
    sed -e '
$a\
# BEGIN LanSafe for SNMP settings
$a\
smux         1.3.6.1.2.1.33.1        PowerMonitorAgent_passwd '$zero_ip' '$zero_ip' # LanSafe SNMP Agent
$a\
# END LanSafe for SNMP settings
/^# BEGIN LanSafe for SNMP settings/,/^# END LanSafe for SNMP settings/d
' ${snmpd_conf} > $snmpd_conf.ls.$$

   check_fatal

    # Report differences
    echo
#    echo "Modified: $snmpd_conf" >> $instpath/Bin/installed.snmp
#    echo "The following lines were removed from $snmpd_conf:"
#    diff ${snmpd_conf}.ls.$$ $snmpd_conf | grep '^>' | sed -e 's/> //'
#    echo "The following lines were added to $snmpd_conf:"
#    diff ${snmpd_conf}.ls.$$ $snmpd_conf | grep '^<' | sed -e 's/< //'

    lineStr=`head -$MODIFIED_SERVICES $INSTALLRES |tail -1`
    echo "$lineStr $snmpd_conf" >> $instpath/Bin/installed.snmp
#    lineStr=`head -$REMOVE_SERVICE_STR $INSTALLRES |tail -1`
#    echo "$lineStr $snmpd_conf:"
#    diff ${snmpd_conf}.ls.$$ $snmpd_conf | grep '^>' | sed -e 's/> //'
#    lineStr=`head -$ADD_SERVICE_STR $INSTALLRES |tail -1`
#    echo "$lineStr $snmpd_conf:"
#    diff ${snmpd_conf}.ls.$$ $snmpd_conf | grep '^<' | sed -e 's/< //'

   # Copy modifed file back to original
   cp $snmpd_conf.ls.$$ ${snmpd_conf}
   check_fatal

   rm -f $snmpd_conf.ls.$$
}


aix_setup_snmpdv3_conf () {
    snmpd_conf=/etc/snmpdv3.conf
    # Backup old snmpd.conf
    cp $snmpd_conf ${snmpd_conf}.ls.$$
    check_fatal
    sed -e '
$a\
# BEGIN LanSafe for SNMP settings
$a\
smux         1.3.6.1.2.1.33.1        PowerMonitorAgent_passwd '$zero_ip' '$zero_ip' # LanSafe SNMP Agent
$a\
# END LanSafe for SNMP settings
/^# BEGIN LanSafe for SNMP settings/,/^# END LanSafe for SNMP settings/d
' ${snmpd_conf} > $snmpd_conf.ls.$$

   check_fatal

    # Report differences
    echo
#    echo "Modified: $snmpd_conf" >> $instpath/Bin/installed.snmp
#    echo "The following lines were removed from $snmpd_conf:"
#    diff ${snmpd_conf}.ls.$$ $snmpd_conf | grep '^>' | sed -e 's/> //'
#    echo "The following lines were added to $snmpd_conf:"
#    diff ${snmpd_conf}.ls.$$ $snmpd_conf | grep '^<' | sed -e 's/< //'

    lineStr=`head -$MODIFIED_SERVICES $INSTALLRES |tail -1`
    echo "$lineStr $snmpd_conf" >> $instpath/Bin/installed.snmp
#    lineStr=`head -$REMOVE_SERVICE_STR $INSTALLRES |tail -1`
#    echo "$lineStr $snmpd_conf:"
#    diff ${snmpd_conf}.ls.$$ $snmpd_conf | grep '^>' | sed -e 's/> //'
#    lineStr=`head -$ADD_SERVICE_STR $INSTALLRES |tail -1`
#    echo "$lineStr $snmpd_conf:"
#    diff ${snmpd_conf}.ls.$$ $snmpd_conf | grep '^<' | sed -e 's/< //'

   # Copy modifed file back to original
   cp $snmpd_conf.ls.$$ ${snmpd_conf}
   check_fatal

   rm -f $snmpd_conf.ls.$$
}


# This one inserts trap receiver into /etc/snmpd.conf
OLD_aix_setup_snmpd_conf () {
    snmpd_conf=/etc/snmpd.conf
    # Backup old snmpd.conf
    cp $snmpd_conf ${snmpd_conf}.ls.$$
    check_fatal

    if [ -z "$trap_line_needed" ]; then
      sed -e '
$a\
# BEGIN LanSafe for SNMP settings
$a\
community    private         '$zero_ip'     '$zero_ip'  readWrite   1.3.33
$a\
view         1.3.33                  1.3.6.1.2.1.33.1
$a\
smux         1.3.6.1.2.1.33.1        PowerMonitorAgent_passwd '$zero_ip' '$zero_ip' # LanSafe SNMP Agent
$a\
# END LanSafe for SNMP settings
/^# BEGIN LanSafe for SNMP settings/,/^# END LanSafe for SNMP settings/d
' ${snmpd_conf} > $snmpd_conf.ls.$$
    else
       # here we add line
       # trap public $trap_receiver 1.3.33.1 fe
      sed -e '
$a\
# BEGIN LanSafe for SNMP settings
$a\
community    private         '$zero_ip'     '$zero_ip'  readWrite   1.3.33
$a\
trap         public                  '$trap_receiver' 1.3.33.1     fe
$a\
view         1.3.33                  1.3.6.1.2.1.33.1
$a\
smux         1.3.6.1.2.1.33.1        PowerMonitorAgent_passwd '$zero_ip' '$zero_ip' # LanSafe SNMP Agent
$a\
# END LanSafe for SNMP settings
/^# BEGIN LanSafe for SNMP settings/,/^# END LanSafe for SNMP settings/d
' ${snmpd_conf} > $snmpd_conf.ls.$$
    fi

   check_fatal

    # Report differences
    echo
#    echo "Modified: $snmpd_conf" >> $instpath/Bin/installed.snmp
#    echo "The following lines were removed from $snmpd_conf:"
#    diff ${snmpd_conf}.ls.$$ $snmpd_conf | grep '^>' | sed -e 's/> //'
#    echo "The following lines were added to $snmpd_conf:"
#    diff ${snmpd_conf}.ls.$$ $snmpd_conf | grep '^<' | sed -e 's/< //'

    lineStr=`head -$MODIFIED_SERVICES $INSTALLRES |tail -1`
    echo "$lineStr $snmpd_conf" >> $instpath/Bin/installed.snmp
#    lineStr=`head -$REMOVE_SERVICE_STR $INSTALLRES |tail -1`
#    echo "$lineStr $snmpd_conf:"
#    diff ${snmpd_conf}.ls.$$ $snmpd_conf | grep '^>' | sed -e 's/> //'
#    lineStr=`head -$ADD_SERVICE_STR $INSTALLRES |tail -1`
#    echo "$lineStr $snmpd_conf:"
#    diff ${snmpd_conf}.ls.$$ $snmpd_conf | grep '^<' | sed -e 's/< //'

   # Copy modifed file back to original
   cp $snmpd_conf.ls.$$ ${snmpd_conf}
   check_fatal

   rm -f $snmpd_conf.ls.$$
}


aix_inittab_startatboot () {
    inittab=/etc/inittab
    # Backup old inittab
    mv -f $inittab ${inittab}.lsagent
    check_fatal
    # Use sed to remove old occurance of form below and add new
    # lines of the form below
    # ls3agent:234:once:$instpath/PowerMonitorAgent
    if [ $startatboot = "yes" ]; then
        sed -e '
$a\
PowerMonitorAgent:234:once:'$instpath'/Bin/PowerMonitorAgent&
/^PowerMonitorAgent:234:once:/d
' ${inittab}.PowerMonitorAagent > $inittab
        check_fatal
    else
        sed -e '
/^PowerMonitorAgent:234:once:/d
' ${inittab}.PowerMonitorAagent > $inittab
        check_fatal
    fi
    
	# Fixup perms on inittab.
    chmod 444 $inittab
    check_fatal

    # Report differences
    echo
#    echo "Modified: $inittab" >> $instpath/Bin/installed.snmp
#    echo "The following lines were removed from $inittab:"
#    diff ${inittab}.PowerMonitorAagent $inittab | grep '^<' | sed -e 's/< //'
#    echo "The following lines were added to $inittab:"
#    diff ${inittab}.PowerMonitorAagent $inittab | grep '^>' | sed -e 's/> //'

    lineStr=`head -$MODIFIED_SERVICES $INSTALLRES |tail -1`
    echo "$lineStr $inittab" >> $instpath/installed
#    lineStr=`head -$REMOVE_SERVICE_STR $INSTALLRES |tail -1`
#    echo "$lineStr $inittab:"
#	diff ${inittab}.PowerMonitorAagent $inittab | grep '^<' | sed -e 's/< //'
#    lineStr=`head -$ADD_SERVICE_STR $INSTALLRES |tail -1`
#    echo "$lineStr $inittab:"
#	diff ${inittab}.PowerMonitorAagent $inittab | grep '^>' | sed -e 's/> //'

}

aix_setup_snmpd_peers () {
    snmpd_peers=/etc/snmpd.peers
    # Backup old snmpd.peers
    cp $snmpd_peers ${snmpd_peers}.ls.$$
    check_fatal

    # Use sed to remove old occurance of form below and add new
    # lines of the form below
    # "ls3agent" 1.3.6.1.2.1.33.1              "ls3agent_passwd"
    sed -e '
$a\
"PowerMonitorAgent" 1.3.6.1.2.1.33.1              "PowerMonitorAgent_passwd"
/^"PowerMonitorAgent" 1.3.6.1.2.1.33.1/d
' $snmpd_peers > ${snmpd_peers}.ls.$$
check_fatal

    # Report differences
    echo
#    echo "Modified: $snmpd_peers" >> $instpath/Bin/installed.snmp
#    echo "The following lines were added from $snmpd_peers:"
#    diff ${snmpd_peers}.ls.$$ $snmpd_peers | grep '^<' | sed -e 's/< //'
#    echo "The following lines were removed to $snmpd_peers:"
#    diff ${snmpd_peers}.ls.$$ $snmpd_peers | grep '^>' | sed -e 's/> //'

    lineStr=`head -$MODIFIED_SERVICES $INSTALLRES |tail -1`
    echo "$lineStr $snmpd_peers" >> $instpath/installed
#    lineStr=`head -$REMOVE_SERVICE_STR $INSTALLRES |tail -1`
#    echo "$lineStr $snmpd_peers:"
#    diff ${snmpd_peers}.ls.$$ $snmpd_peers | grep '^<' | sed -e 's/< //'
#    lineStr=`head -$ADD_SERVICE_STR $INSTALLRES |tail -1`
#    echo "$lineStr $inittab:"
#    diff ${snmpd_peers}.ls.$$ $snmpd_peers | grep '^>' | sed -e 's/> //'

    # Copy modified file to original
    cp ${snmpd_peers}.ls.$$ $snmpd_peers
    check_fatal
    rm -f ${snmpd_peers}.ls.$$
}


aix_setup_mib_defs () {
    mib_defs=/etc/mib.defs

    # Backup old mib.defs
    cp $mib_defs ${mib_defs}.ls.$$
    check_fatal

    # Use sed to remove old occurance of UPS-MIB i.e. ALL the lines
    # between lines:
    # -- BEGIN LanSafe MIB Defs
    # and
    # -- END LanSafe MIB Defs
    sed -e '
/^-- BEGIN LanSafe MIB Defs/,/^-- END LanSafe MIB Defs/d
' ${mib_defs}.ls.$$ > $mib_defs
check_fatal
    # Concatenate rfc1628.defs files into the end of /etc/mib.defs
    cat $instpath/Bin/rfc1628.defs >>$mib_defs
    check_fatal

    # Report differences
    echo
#    echo "Modified: $mib_defs. See $instpath/Bin/installed.snmp for details."
#    echo "Modified: $mib_defs" >> $instpath/Bin/installed.snmp
#    echo "The following lines were removed from $mib_defs:"  >> $instpath/Bin/installed.snmp
#    diff ${mib_defs}.ls.$$ $mib_defs | grep '^<' | sed -e 's/< //'  >> $instpath/Bin/installed.snmp
#    echo "The following lines were added to $mib_defs:"  >> $instpath/Bin/installed.snmp
#    diff ${mib_defs}.ls.$$ $mib_defs | grep '^>' | sed -e 's/> //'  >> $instpath/Bin/installed.snmp

    lineStr=`head -$MODIFIED_SERVICES $INSTALLRES |tail -1`
    lineStr1=`head -$MIB_MODIFY_STR1 $INSTALLRES |tail -1`
    lineStr2=`head -$MIB_MODIFY_STR2 $INSTALLRES |tail -1`
    echo "$lineStr $mib_defs. $lineStr1 $instpath/Bin/installed.snmp $lineStr2"
    echo "$lineStr $mib_defs" >> $instpath/Bin/installed.snmp
#    lineStr=`head -$REMOVE_SERVICE_STR $INSTALLRES |tail -1`
#    echo "$lineStr $mib_defs:"
#    diff ${mib_defs}.ls.$$ $mib_defs | grep '^<' | sed -e 's/< //'  >> $instpath/Bin/installed.snmp
#    lineStr=`head -$ADD_SERVICE_STR $INSTALLRES |tail -1`
#    echo "$lineStr $mib_defs:"
#    diff ${mib_defs}.ls.$$ $mib_defs | grep '^>' | sed -e 's/> //'  >> $instpath/Bin/installed.snmp

    rm -f ${mib_defs}.ls.$$
}

# AIX specific procedures end here
# HP-UX specific procedures start here

compute_hpux_system () {
    set `uname -a`
    case $3 in
	    *.11.*)
		echo hpux10
		;;
	    *.10.*)
		echo hpux10
		;;
	    *)
		echo hpux9
		;;
    esac
}

compute_hpux_SYSTEM () {
    set `uname -a`
    case $3 in
	    *.11.*)
		echo HPUX10
		;;
	    *.10.*)
		echo HPUX10
		;;
	    *)
		echo HPUX9
		;;
    esac
}

hpux_check_for_dfix1350 () {

# This checks if DFIX 1350 patch is installed on HP-UX 9.x
case $hp_system in
  hpux9)
	 # Ext. subagent file for HP-UX 9.x is /etc/snmpd.ea
	 what `hpux_get_extend_file` | grep "Contains DFIX1350" >/dev/null 2>/dev/null

	 if [ $? = 0 ]; then
#        echo "WARNING! Patch DFIX1350 is not installed in HP OpenView Extensible SNMP Agent /etc/snmpd.ea."
        lineStr=`head -$ERR_HPUX_PATCH $INSTALLRES |tail -1`
        echo "$lineStr"
	   echo
	 fi
  ;;
  *)
         # null
  ;;
esac
}

# Only for hpux 9.x
hpux_check_for_agentversion () {
# This checks the version number of Extensible subagent on HP-UX 9.x
case $hp_system in
  hpux9)
	 # Ext. subagent file for HP-UX 9.x is /etc/snmpd.ea
	 what `hpux_get_extend_file` | grep "Release 3." >/dev/null 2>/dev/null

	 if [ $? = 0 ]; then
	   echo extagentv4
	 else
	   echo extagentv3
	 fi
  ;;
  *)
         # null
  ;;
esac
}

hpux_check_for_counter32 () {

extend_file=`hpux_get_extend_file`
case $hp_system in
  hpux9)
		# hpux9 extend_file is /etc/snmp.ea
		grep "Counter32 ::= INTEGER" $extend_file >/dev/null 2>/dev/null

	 if [ $? != 0 ]; then
	   # counter32 not found
	   echo "Counter32 ::= INTEGER" >>$extend_file
	 fi
  ;;
  *)
     # null
  ;;
esac
}

hpux_check_extended_agent () {

case $hp_system in

  hpux9)
	 # XXX
	   ps -e | awk '{ if (match($4, "snmpd.ea") != 0) exit 1 }'
	     if [ $? = 1 ] ; then
	       # Ext. agent is running
	     echo
#	     echo "Good! Extensible Agent for HP-UX is running."
         lineStr=`head -$HPUX_EXT_AGENT_GOOD $INSTALLRES |tail -1`
         echo "$lineStr"
	      extagent_running=true
	    elif [ -x /etc/snmpd.ea ]; then
	      # Ext. agent is not running, but it is installed
	      echo
#	      echo "WARNING! Extensible Agent for HP-UX is installed on this system, "
#	      echo "but it is not running."
#	      echo
#	      echo "You need to have Extensible Agent from HP-UX running on your system."
#	      echo "to be able to run LanSafe SNMP agent PowerMonitorAgent."

          lineStr=`head -$ERR_NORUN_HPUX_EXT_AGENT_STR1 $INSTALLRES |tail -1`
          echo "$lineStr"
          lineStr=`head -$ERR_NORUN_HPUX_EXT_AGENT_STR2 $INSTALLRES |tail -1`
          echo "$lineStr"
	      echo
          lineStr=`head -$ERR_NORUN_HPUX_EXT_AGENT_STR3 $INSTALLRES |tail -1`
          echo "$lineStr"
          lineStr=`head -$ERR_NORUN_HPUX_EXT_AGENT_STR4 $INSTALLRES |tail -1`
          echo "$lineStr"

	      extagent_running=true
	      snmpd_running=true
	    else
	      echo
	      echo "Extensible Agent for HP-UX is not installed on this system."
	      echo
	      echo "If you purchase Extensible Agent from HP, you can later install"
	      echo "LanSafe SNMP Agent by running this agent.sh script."
	      echo
	      echo "Can't continue LanSafe SNMP Agent installation. Exiting."

          lineStr=`head -$ERR_NO_EXIST_HPUX_EXT_AGENT_STR1 $INSTALLRES |tail -1`
          echo "$lineStr"
	      echo
          lineStr=`head -$ERR_NO_EXIST_HPUX_EXT_AGENT_STR2 $INSTALLRES |tail -1`
          echo "$lineStr"
          lineStr=`head -$ERR_NO_EXIST_HPUX_EXT_AGENT_STR3 $INSTALLRES |tail -1`
          echo "$lineStr"
	      echo
          lineStr=`head -$ERR_NO_EXIST_HPUX_EXT_AGENT_STR4 $INSTALLRES |tail -1`
          echo "$lineStr"


	      exit 1
	      extagent_running=""
	      snmpd_running=""
	    fi
  ;;
  hpux10)
# On HP-UX 10.x:
# ls -ls /usr/sbin/extsubagt
# 1776 -r-xr-xr-x   1 root       sys         898616 Jun 10  1997 /usr/sbin/extsubagt
# ls -ls /usr/sbin/*.ea
#   2 lrwxrwxr-x   1 root       sys             15 Apr 17  1997 /usr/sbin/snmpd.ea -> /usr/sbin/snmpd
	  ps -e | awk '{ if (match($4, "extsubagt") != 0) exit 1 }'
	    if [ $? = 1 ] ; then
	      # Ext. agent is running
	      echo
	      echo "Good! Extensible Agent for HP-UX is running."
	      extagent_running=true
	    elif [ -x /usr/sbin/extsubagt ]; then
	      # Ext. agent is not running, but it is installed
	      echo
#	      echo "WARNING! Extensible Agent for HP-UX is installed on this system, "
#	      echo "but it is not running."
#	      echo
#	      echo "You need to have Extensible Agent from HP-UX running on your system."
#	      echo "to be able to run LanSafe SNMP agent PowerMonitorAgent."

          lineStr=`head -$ERR_NORUN_HPUX_EXT_AGENT_STR1 $INSTALLRES |tail -1`
          echo "$lineStr"
          lineStr=`head -$ERR_NORUN_HPUX_EXT_AGENT_STR2 $INSTALLRES |tail -1`
          echo "$lineStr"
	      echo
          lineStr=`head -$ERR_NORUN_HPUX_EXT_AGENT_STR3 $INSTALLRES |tail -1`
          echo "$lineStr"
          lineStr=`head -$ERR_NORUN_HPUX_EXT_AGENT_STR4 $INSTALLRES |tail -1`
          echo "$lineStr"
 	      extagent_running=true
	      snmpd_running=true
	    else
	      echo
#	      echo "Extensible Agent for HP-UX is not installed on this system."
#	      echo
#	      echo "If you purchase Extensible Agent from HP, you can later install"
#	      echo "LanSafe SNMP Agent by running this hpagent.sh script."
#	      echo
#	      echo "Can't continue LanSafe SNMP Agent installation. Exiting."
          lineStr=`head -$ERR_NO_EXIST_HPUX_EXT_AGENT_STR1 $INSTALLRES |tail -1`
          echo "$lineStr"
	      echo
          lineStr=`head -$ERR_NO_EXIST_HPUX_EXT_AGENT_STR2 $INSTALLRES |tail -1`
          echo "$lineStr"
          lineStr=`head -$ERR_NO_EXIST_HPUX_EXT_AGENT_STR3 $INSTALLRES |tail -1`
          echo "$lineStr"
	      echo
          lineStr=`head -$ERR_NO_EXIST_HPUX_EXT_AGENT_STR4 $INSTALLRES |tail -1`
          echo "$lineStr"
	      exit 1
	      extagent_running=""
	      snmpd_running=""
	    fi
	    ;;
esac
}

hpux_setup_extend_file () {
    # hp 9.x /etc/snmpd.extend
    # hp 10.x /etc/SnmpAgent.d/snmpd.extend

    case $hp_system in
	hpux9)
	        if [ x"$hpux9_agentversion" = xextagentv3 ]; then
		    extend_file=/etc/snmpd.extend
		    file_to_add=$instpath/Bin/snmpd.extend.v3
		else
		    # Ext. subagent v4 on hpux9
		    extend_file=/etc/SnmpAgent.d/snmpd.extend
		    file_to_add=$instpath/Bin/snmpd.extend.v4
		fi
	;;
	hpux10)
		extend_file=/etc/SnmpAgent.d/snmpd.extend
		file_to_add=$instpath/Bin/snmpd.extend.v4
        ;;
    esac

    # Backup old extend file.
    if [ -f "$extend_file" ]; then
      cp $extend_file ${extend_file}.ls.$$
      check_fatal
      #echo "Backing up original "$extend_file" as ${extend_file}.ls."
      #cp -p $extend_file ${extend_file}.ls
      check_fatal
    else
      touch ${extend_file}.ls.$$
    fi

    if [ ! -f "$extend_file" ]; then
      echo
#      echo "File $extend_file does not exist on your system."
#      echo
#      echo "Creating $extend_file and adding rfc1628 MIB to it..."

      lineStr=`head -$ $INSTALLRES |tail -1`
      echo "$extend_file $lineStr"
      echo
      lineStr=`head -$ $INSTALLRES |tail -1`
      echo "$extend_file $lineStr"

      cat $file_to_add >>$extend_file
      check_fatal
      echo "Done."
    else

    # Use sed to remove old occurance of UPS-MIB i.e. ALL the lines
    # between lines:
    # -- BEGIN LanSafe MIB Defs
    # and
    # -- END LanSafe MIB Defs
    sed -e '
/^-- BEGIN LanSafe MIB Defs/,/^-- END LanSafe MIB Defs/d
' ${extend_file}.ls.$$ > $extend_file
check_fatal
    # Concatenate rfc1628.defs files into the end of $extend_file
    cat $file_to_add >>$extend_file
    check_fatal
  fi
    # Report differences
    echo
#    echo "Modified: $extend_file. "
#    echo "See $instpath/Bin/installed.snmp for details."
#    echo "Modified: $extend_file" >> $instpath/Bin/installed.snmp
#    echo "The following lines were removed from $extend_file:"  >> $instpath/Bin/installed.snmp
#    diff ${extend_file}.ls.$$ $extend_file | grep '^<' | sed -e 's/< //'  >> $instpath/Bin/installed.snmp
#    echo "The following lines were added to $extend_file:"  >> $instpath/Bin/installed.snmp
#    diff ${extend_file}.ls.$$ $extend_file | grep '^>' | sed -e 's/> //'  >> $instpath/Bin/installed.snmp


    lineStr=`head -$MODIFIED_SERVICES $INSTALLRES |tail -1`
    lineStr1=`head -$MIB_MODIFY_STR1 $INSTALLRES |tail -1`
    lineStr2=`head -$MIB_MODIFY_STR2 $INSTALLRES |tail -1`
    echo "$lineStr: $extend_file."
    echo "$lineStr1 $instpath/Bin/installed.snmp $lineStr2"
    echo "$lineStr $snmpd_conf" >> $instpath/Bin/installed.snmp

#    lineStr=`head -$REMOVE_SERVICE_STR $INSTALLRES |tail -1`
#    echo "$lineStr $extend_file:"
#    diff ${extend_file}.ls.$$ $extend_file | grep '^<' | sed -e 's/< //'  >> $instpath/Bin/installed.snmp
#    lineStr=`head -$ADD_SERVICE_STR $INSTALLRES |tail -1`
#    echo "$lineStr $extend_file:"
#    diff ${extend_file}.ls.$$ $extend_file | grep '^>' | sed -e 's/> //'  >> $instpath/Bin/installed.snmp


    rm -f ${extend_file}.ls.$$
}

hpux_find_snmptrap_path () {
# This will find the path to snmptrap
# and echo it back to be used in PATH definition
# in the beginning of lsagent.init
case $hp_system in

  hpux9)
	# XXX
	 if [ -x /usr/OV/bin/snmptrap ]; then
	   trap_path=/usr/OV/bin
	 elif [ -x /bin/snmptrap ]; then
	   trap_path=/bin
	 fi
	 ;;
  hpux10)
	  if [ -x /opt/OV/bin/snmptrap ]; then
	    trap_path=/opt/OV/bin
	  else
	    do_find_for_snmp_trap
	  fi
	  ;;
esac
}

hpux_do_find_for_snmp_trap () {

find / -name snmptrap -fsonly hfs -print 1>/tmp/hpagentfind.$$ 2>/dev/null

if [ -f /tmp/hpagentfind.$$ ]; then
  for eachfile in `cat /tmp/hpagentfind.$$`
    do
      if [ -x $eachfile ]; then
	trap_path=`basename "$eachfile"`
	continue 2
      fi
    done
else
  echo
#  echo "Can't find snmptrap executable on your system. Check your system setup."
#  echo "You will not be able to receive traps from PowerMonitorAgent to your management station."
    lineStr=`head -$ERR_HPUX_TRAP_STR1 $INSTALLRES |tail -1`
    echo "$lineStr"
    lineStr=`head -$ERR_HPUX_TRAP_STR2 $INSTALLRES |tail -1`
    echo "$lineStr"
  trap_path=""
fi

rm -f /tmp/hpagentfind.$$

}

hpux_get_extend_file () {

case $hp_system in

    hpux9)
	echo /etc/snmpd.extend
    ;;
    hpux10)
	echo /etc/SnmpAgent.d/snmpd.extend
    ;;
esac

}

hpux10_startatboot () {

  initfile=/sbin/init.d/lsagent.init
  startfile=/sbin/rc2.d/S760lsagent.init
  stopfile=/sbin/rc1.d/K485lsagent.init

# This returns trap_path
  hpux_find_snmptrap_path

#   Cleanup previous install

  if [ -f $initfile ]; then
    rm -f $initfile
#    echo "Removed: $initfile" >> $instpath/Bin/installed.snmp
    lineStr=`head -$REMOVED_STR $INSTALLRES |tail -1`
    echo "$lineStr $initfile" >> $instpath/Bin/installed.snmp
  fi

  if [ -f $startfile ]; then
    rm -f $startfile
#    echo "Removed: $startfile" >> $instpath/Bin/installed.snmp
    lineStr=`head -$REMOVED_STR $INSTALLRES |tail -1`
    echo "$lineStr $startfile" >> $instpath/Bin/installed.snmp
  fi

  if [ -f $stopfile ]; then
    rm -f $stopfile
#    echo "Removed: $stopfile" >> $instpath/Bin/installed.snmp
    lineStr=`head -$REMOVED_STR $INSTALLRES |tail -1`
    echo "$lineStr $stopfile" >> $instpath/Bin/installed.snmp
  fi

  # Copy ls.init while setting install path
  if [ -n "$cdrom_install" ]; then
#    InstallFile=1_INSTAL/LSAGENT.INI
    InstallFile=1_install/lsagent.init
  else
    InstallFile=1_install/lsagent.init
  fi

# Old sed line sed '/PATH=\$PATH:\/usr\/OV\/bin\/snmptrap; export PATH/\c

  if [ "$startatboot" = "yes" ]; then
#    echo_n "Installing lsagent.init to init.d ... "
    lineStr=`head -$INSTALL_FROM $INSTALLRES |tail -1`
    lineStr1=`head -$INSTALL_TO $INSTALLRES |tail -1`
    echo_n "$lineStr lsagent.init $lineStr1 init.d ... "

sed -e '/PATH=/c\
PATH=$PATH:'$trap_path'; export PATH
/\usr\/ls3/c\
instpath='$instpath'
    ' $InstallFile > $initfile
    check_fatal
    # Set permissions
    chmod 755 $initfile
    check_fatal
#    echo "Installed: $initfile" >> $instpath/Bin/installed.snmp
#    echo "done"

    lineStr=`head -$INSTALLED_STR $INSTALLRES |tail -1`
    echo "$lineStr $initfile" >> $instpath/Bin/installed.snmp
    lineStr=`head -$INSTALLED_DONE $INSTALLRES |tail -1`
    echo "$lineStr"

    # Link init file in rc dirs.
#    echo_n "Linking $startfile to $initfile ... "
    lineStr=`head -$LINK_FILE_STR $INSTALLRES |tail -1`
    lineStr1=`head -$INSTALL_TO $INSTALLRES |tail -1`
    echo_n "$lineStr $startfile $lineStr1 $initfile ... "
    if [ -d /sbin/init.d -o -d /etc/rc.d/init.d ]; then
      ln -fs $initfile $startfile
    else
      ln $initfile $startfile
    fi
    check_fatal
#    echo "Linked: $startfile to $initfile" >> $instpath/installed.snmp
#    echo "done"
    lineStr=`head -$LINKED_STR $INSTALLRES |tail -1`
    lineStr1=`head -$INSTALL_TO $INSTALLRES |tail -1`
    echo "lineStr $startfile $lineStr1 $initfile" >> $instpath/installed.snmp
    lineStr=`head -$INSTALLED_DONE $INSTALLRES |tail -1`
    echo "$lineStr"

#    echo_n "Linking $stopfile to $initfile ... "
    lineStr=`head -$LINK_FILE_STR $INSTALLRES |tail -1`
    lineStr1=`head -$INSTALL_TO $INSTALLRES |tail -1`
    echo_n "$lineStr $stopfile $lineStr1 $initfile ... "
    if [ -d /sbin/init.d -o -d /etc/rc.d/init.d ]; then
      ln -fs $initfile $stopfile
    else
      ln $initfile $stopfile
    fi
    check_fatal
#    echo "Linked: $stopfile to $initfile" >> $instpath/installed.snmp
#    echo "done"
    lineStr=`head -$LINKED_STR $INSTALLRES |tail -1`
    lineStr1=`head -$INSTALL_TO $INSTALLRES |tail -1`
    echo "lineStr $stopfile $lineStr1 $initfile" >> $instpath/installed.snmp
    lineStr=`head -$INSTALLED_DONE $INSTALLRES |tail -1`
    echo "$lineStr"
  fi
# end-of hpux10_startatboot
}

# This is not called anymore, since /usr/Powerware/LanSafe/Bin/PowerMonitor.sh 
# takes care of starting PowerMonitorAgent.
hpux9_startatboot () {

    inittab=/etc/inittab

    # Backup old inittab
    mv -f $inittab ${inittab}.ls3agent
    check_fatal

    # Use sed to remove old occurance of form below and add new
    # lines of the form below
    # ls3agent:234:once:$instpath/ls3agent.sh
    if [ $startatboot = "yes" ]; then
	sed -e '
$a\
ls3agent:234:once:'$instpath'/ls3agent.sh&
/^ls3agent:234:once:/d
' ${inittab}.ls3agent > $inittab
	check_fatal
    else
	sed -e '
/^ls3agent:234:once:/d
' ${inittab}.ls3agent > $inittab
	check_fatal
    fi

    # Fixup perms on inittab.
    chmod 444 $inittab
    check_fatal

    # Report differences
#    echo "Modified: $inittab" >> $instpath/installed.snmp
#    echo "The following lines were removed from $inittab:"
#    diff ${inittab}.lsagent $inittab | grep '^<' | sed -e 's/< //'
#    echo "The following lines were added to $inittab:"
#    diff ${inittab}.lsagent $inittab | grep '^>' | sed -e 's/> //'

    lineStr=`head -$MODIFIED_SERVICES $INSTALLRES |tail -1`
    echo "$lineStr $inittab" >> $instpath/Bin/installed.snmp
#    lineStr=`head -$REMOVE_SERVICE_STR $INSTALLRES |tail -1`
#    echo "$lineStr $inittab:"
#    diff ${inittab}.lsagent $inittab | grep '^<' | sed -e 's/< //'
#    lineStr=`head -$ADD_SERVICE_STR $INSTALLRES |tail -1`
#    echo "$lineStr $inittab:"
#    diff ${inittab}.lsagent $inittab | grep '^>' | sed -e 's/> //'


# modify ls3agent.sh

	InstallFile=$instpath/lsagent.tmp
	FinalFile=$instpath/lsagent.sh
	mv $FinalFile $InstallFile

	sed '/\usr\/ls3/c\
instpath='$instpath'
' $InstallFile > $FinalFile

	chmod 744 $instpath/lsagent.sh

}

# HP-UX specific procedures end here
# SCO5 specific procedures start here

sco5_setup_snmpd_peers () {

    snmpd_peers=/etc/snmpd.peers

    # Backup old snmpd.peers
    cp $snmpd_peers ${snmpd_peers}.ls.$$
    check_fatal

    # Use sed to remove old occurance of form below and add new
    # lines of the form below
    # "ls3agent" 1.3.6.1.2.1.33.1              "ls3agent_passwd"
    sed -e '
$a\
"PowerMonitorAgent" 1.3.6.1.2.1.33.1              "PowerMonitorAgent_passwd"
/^"PowerMonitorAgent" 1.3.6.1.2.1.33.1/d
' $snmpd_peers > ${snmpd_peers}.ls.$$
check_fatal

    # Report differences
    echo
#    echo "Modified: $snmpd_peers" >> $instpath/installed.snmp
#    echo "The following lines were added from $snmpd_peers:"
#    diff ${snmpd_peers}.ls.$$ $snmpd_peers | grep '^<' | sed -e 's/< //'
#    echo "The following lines were removed to $snmpd_peers:"
#    diff ${snmpd_peers}.ls.$$ $snmpd_peers | grep '^>' | sed -e 's/> //'

    lineStr=`head -$MODIFIED_SERVICES $INSTALLRES |tail -1`
    echo "$lineStr $snmpd_peers" >> $instpath/Bin/installed.snmp
#    lineStr=`head -$REMOVE_SERVICE_STR $INSTALLRES |tail -1`
#    echo "$lineStr $snmpd_peers:"
#    diff ${snmpd_peers}.ls.$$ $snmpd_peers | grep '^<' | sed -e 's/< //'
#    lineStr=`head -$ADD_SERVICE_STR $INSTALLRES |tail -1`
#    echo "$lineStr $snmpd_peers:"
#    diff ${snmpd_peers}.ls.$$ $snmpd_peers | grep '^>' | sed -e 's/> //'

    # Copy modified file to original
    cp ${snmpd_peers}.ls.$$ $snmpd_peers
    check_fatal
    rm -f ${snmpd_peers}.ls.$$
}

sco5_check_snmpd () {
# $4 is the last field in ps -ef output of sco5.
ps -e | awk '{ if (match($4, "snmpd") != 0) exit 1 }'
   if [ $? = 1 ] ; then
       # SNMP daemon is running
       snmpd_running=true
   else
       # SNMP daemon is not running
       snmpd_running=
  fi
}

# SCO5 specific procedures end here
# UnixWare2 specific procedures start here
uw2_setup_snmpd_peers () {

    snmpd_peers=/etc/netmgt/snmpd.peers
    # Backup old snmpd.peers
    cp $snmpd_peers ${snmpd_peers}.ls3.$$
    check_fatal
    # Use sed to remove old occurance of form below and add new lines of the form below
    # "ls3agent" 1.3.6.1.2.1.33.1              "ls3agent_passwd"
    sed -e '
$a\
"ls3agent" 1.3.6.1.2.1.33.1              "ls3agent_passwd"
/^"ls3agent" 1.3.6.1.2.1.33.1/d
' $snmpd_peers > ${snmpd_peers}.ls3.$$
check_fatal

    # Report differences
    echo
#    echo "Modified: $snmpd_peers" >> $instpath/installed.snmp
#    echo "The following lines were added from $snmpd_peers:"
#    diff ${snmpd_peers}.ls.$$ $snmpd_peers | grep '^<' | sed -e 's/< //'
#    echo "The following lines were removed to $snmpd_peers:"
#    diff ${snmpd_peers}.ls.$$ $snmpd_peers | grep '^>' | sed -e 's/> //'

    lineStr=`head -$MODIFIED_SERVICES $INSTALLRES |tail -1`
    echo "$lineStr $snmpd_peers" >> $instpath/Bin/installed.snmp
#    lineStr=`head -$REMOVE_SERVICE_STR $INSTALLRES |tail -1`
#    echo "$lineStr $snmpd_peers:"
#    diff ${snmpd_peers}.ls.$$ $snmpd_peers | grep '^<' | sed -e 's/< //'
#    lineStr=`head -$ADD_SERVICE_STR $INSTALLRES |tail -1`
#    echo "$lineStr $inittab:"
#    diff ${snmpd_peers}.ls.$$ $snmpd_peers | grep '^>' | sed -e 's/> //'


    # Copy modified file to original
    cp ${snmpd_peers}.ls.$$ $snmpd_peers
    check_fatal
    rm -f ${snmpd_peers}.ls.$$
}

uw2_check_snmpd () {
# $6 is the last field in ps -ef output of uw2.
ps -e | awk '{ if (match($6, "in.snmpd") != 0) exit 1 }'
   if [ $? = 1 ] ; then
       # SNMP daemon is running
       snmpd_running=true
   else
       # SNMP daemon is not running
       snmpd_running=
  fi
}

# UnixWare2 specific procedures end here
# Solaris 2.x specific procedures start here
solaris_check_extended_agent () {
# On Solaris:
# ls -ls /usr/sbin/extsubagt
# 584 -r-x------  1 root       586188 Feb 10 10:01 /usr/sbin/extsubagt
# ls -ls /usr/sbin/*.ea
#   1 lrwxrwxrwx  1 root           15 Feb 10 10:01 /usr/sbin/snmpd.ea -> /usr/sbin/snmpd
# $4 is the last field in ps -e output of Solaris.
# MUST use awk's index instead of match here.
# MUST try to find match for extsubag (NOT extsubagt), since last field
# in "ps -e" output is truncated.
ps -e | awk '{ if (index($4, "extsubag") != 0) exit 1 }'
    if [ $? = 1 ] ; then
	# Ext. agent is running
	echo
#	echo "Good! Extensible Agent for Solaris is running."
    lineStr=`head -$SOL_EXT_AGENT_GOOD $INSTALLRES |tail -1`
    echo "$lineStr"
       extagent_running=true
    elif [ -x /usr/sbin/extsubagt ] ;then
	# Ext. agent is not running, but it is installed
	echo
#	echo ".WARNING! Extensible Agent for Solaris is installed on this system, "
#	echo "but it is not running."
#	echo
#	echo "You need to have Extensible Agent from Solaris running on your system."
#	echo "to be able to run LanSafe SNMP agent PowerMonitorAgent."
    lineStr=`head -$ERR_NORUN_SOL_EXT_AGENT_STR1 $INSTALLRES |tail -1`
    echo "$lineStr"
    lineStr=`head -$ERR_NORUN_SOL_EXT_AGENT_STR2 $INSTALLRES |tail -1`
    echo "$lineStr"
    echo
    lineStr=`head -$ERR_NORUN_SOL_EXT_AGENT_STR3 $INSTALLRES |tail -1`
    echo "$lineStr"
    lineStr=`head -$ERR_NORUN_SOL_EXT_AGENT_STR4 $INSTALLRES |tail -1`
    echo "$lineStr"
	extagent_running=true
	snmpd_running=true
    else
	echo
#	echo ".Extensible Agent for Solaris is not installed on this system."
#	echo
#	echo "If you purchase Extensible Agent from Sun Microsystems, you can later install"
#	echo "LanSafe SNMP Agent by running this agent.sh script."
#	echo
#	echo "Can't continue LanSafe SNMP Agent installation. Exiting."
    lineStr=`head -$ERR_NO_EXIST_SOL_EXT_AGENT_STR1 $INSTALLRES |tail -1`
    echo "$lineStr"
    echo
    lineStr=`head -$ERR_NO_EXIST_SOL_EXT_AGENT_STR2 $INSTALLRES |tail -1`
    echo "$lineStr"
    lineStr=`head -$ERR_NO_EXIST_SOL_EXT_AGENT_STR3 $INSTALLRES |tail -1`
    echo "$lineStr"
    echo
    lineStr=`head -$ERR_NO_EXIST_SOL_EXT_AGENT_STR4 $INSTALLRES |tail -1`
    echo "$lineStr"

	exit 1
	extagent_running=""
	snmpd_running=""
    fi
}

solaris_setup_extend_file () {

    extend_file=/etc/SnmpAgent.d/snmpd.extend
    file_to_add=$instpath/Bin/snmpd.extend.v4

    # Backup old extend file.
    if [ -f "$extend_file" ]; then
      cp $extend_file ${extend_file}.ls3.$$
      check_fatal
      #echo "Backing up original "$extend_file" as ${extend_file}.ls3."
      #cp -p $extend_file ${extend_file}.ls3
      check_fatal
    else
      touch ${extend_file}.ls3.$$
    fi

    if [ ! -f "$extend_file" ]; then
      echo
#      echo "File $extend_file does not exist on your system."
#      echo
#      echo "Creating $extend_file and adding rfc1628 MIB to it..."
       lineStr=`head -$WARN_HPUX_MODIFY_EXTFILE_STR1 $INSTALLRES |tail -1`
       echo "$lineStr $extend_file"
       echo
       lineStr=`head -$WARN_HPUX_MODIFY_EXTFILE_STR1 $INSTALLRES |tail -1`
       echo "$lineStr $extend_file"

      cat $file_to_add >>$extend_file
      check_fatal
      echo "Done."
    else
    
	# Use sed to remove old occurance of UPS-MIB i.e. ALL the lines
    # between lines:
    # -- BEGIN LanSafe MIB Defs
    # and
    # -- END LanSafe MIB Defs
    sed -e '
/^-- BEGIN LanSafe MIB Defs/,/^-- END LanSafe MIB Defs/d
' ${extend_file}.ls3.$$ > $extend_file
check_fatal
    # Concatenate rfc1628.defs files into the end of $extend_file
    cat $file_to_add >>$extend_file
    check_fatal
  fi
    # Report differences
    echo
#    echo "Modified: $extend_file. "
#    echo "See $instpath/installed.snmp for details."
#    echo "Modified: $extend_file" >> $instpath/installed.snmp
#    echo "The following lines were removed from $extend_file:"  >> $instpath/installed.snmp
#    diff ${extend_file}.ls.$$ $extend_file | grep '^<' | sed -e 's/< //'  >> $instpath/installed.snmp
#    echo "The following lines were added to $extend_file:"  >> $instpath/installed.snmp
#    diff ${extend_file}.ls.$$ $extend_file | grep '^>' | sed -e 's/> //'  >> $instpath/installed.snmp

    lineStr=`head -$MODIFIED_SERVICES $INSTALLRES |tail -1`
    lineStr1=`head -$MIB_MODIFY_STR1 $INSTALLRES |tail -1`
    lineStr2=`head -$MIB_MODIFY_STR2 $INSTALLRES |tail -1`
    echo "$lineStr: $extend_file."
    echo "$lineStr1 $instpath/Bin/installed.snmp $lineStr2"
    echo "$lineStr $extend_file" >> $instpath/Bin/installed.snmp

#    lineStr=`head -$REMOVE_SERVICE_STR $INSTALLRES |tail -1`
#    echo "$lineStr $extend_file:"
#    diff ${extend_file}.ls.$$ $extend_file | grep '^<' | sed -e 's/< //'  >> $instpath/installed.snmp
#    lineStr=`head -$ADD_SERVICE_STR $INSTALLRES |tail -1`
#    echo "$lineStr $extend_file:"
#    diff ${extend_file}.ls.$$ $extend_file | grep '^>' | sed -e 's/> //'  >> $instpath/installed.snmp


    rm -f ${extend_file}.ls.$$
}

# Solaris 2.x specific procedures end here
# Common/shared procedures start here for uw2, sco5 and solaris
sysv_startatboot () {

    if [ -d /etc/init.d ]; then
	initfile=/etc/init.d/lsagent.init

	if [ "$system" = solari -o "$SYSTEM" = SOLARI ]; then
	    startfile=/etc/rc2.d/S99lsagent.init
	else
	    startfile=/etc/rc2.d/S89lsagent.init
	fi

        stopfile=/etc/rc0.d/K99lsagent.init
    else
	echo "Directory /etc/init.d does not exist.."
	echo "Skipping ls3agent modifications to rc files."
	return
    fi

    if [ '(' "$system" = solari -o  "$SYSTEM" = SOLARI ')' -a '(' ! -x /opt/OV/bin/snmptrap ')' ]; then
	    echo ". "
#	    echo "NOTE! snmptrap executable can not be found in its default location /opt/OV/bin."
#	    echo "Please manually edit PATH variable setting in "
#	    echo " "
#	    echo "$initfile and $startfile files."
#	    echo " "
#	    echo "to reflect your system setup."
#	    echo " "

        lineStr=`head -$ERR_SOL_SNMP_TRAP_STR1 $INSTALLRES |tail -1`
        echo "$lineStr"
        lineStr=`head -$ERR_SOL_SNMP_TRAP_STR2 $INSTALLRES |tail -1`
        echo "$lineStr"
        echo " "
        lineStr=`head -$ERR_SOL_SNMP_TRAP_STR3 $INSTALLRES |tail -1`
        lineStr1=`head -$ERR_SOL_SNMP_TRAP_STR4 $INSTALLRES |tail -1`
        echo "$initfile $lineStr $startfile $lineStr1"
        echo " "
        lineStr=`head -$ERR_SOL_SNMP_TRAP_STR5 $INSTALLRES |tail -1`
        echo "$lineStr"
        echo " "


     fi

    # Cleanup from previous install, okay for these to fail
    if [ -f $initfile ]; then
        rm -f $initfile
#        echo "Removed: $initfile" >> $instpath/installed.snmp
        lineStr=`head -$REMOVED_STR $INSTALLRES |tail -1`
        echo "$lineStr $initfile" >> $instpath/installed.snmp
    fi
    if [ -f $startfile ]; then
        rm -f $startfile
#        echo "Removed: $startfile" >> $instpath/installed.snmp
        lineStr=`head -$REMOVED_STR $INSTALLRES |tail -1`
        echo "$lineStr $startfile" >> $instpath/installed.snmp
    fi
    if [ -f $stopfile ]; then
        rm -f $stopfile
#        echo "Removed: $stopfile" >> $instpath/installed.snmp
        lineStr=`head -$REMOVED_STR $INSTALLRES |tail -1`
        echo "$lineStr $stopfile" >> $instpath/installed.snmp
    fi

    # Copy ls3agent.init while setting install path
        if [ -n "$cdrom_install" ]; then
#              InstallFile=1_INSTAL/LSAGENT.INI
              InstallFile=1_install/lsagent.init
        else
              InstallFile=1_install/lsagent.init
        fi

    if [ "$startatboot" = "yes" ]; then
#        echo_n "Installing lsagent.init to init.d ... "
        lineStr=`head -$INSTALL_FROM $INSTALLRES |tail -1`
        lineStr1=`head -$INSTALL_TO $INSTALLRES |tail -1`
        echo_n "$lineStr lsagent.init $lineStr1 init.d ... "
        sed '/\usr\/Powerware\/LanSafe\/Bin/c\
instpath='$instpath"/Bin"'
' $InstallFile > $initfile
        check_fatal
        # Set permissions
        chmod 755 $initfile
        check_fatal
#        echo "Installed: $initfile" >> $instpath/Bin/installed.snmp
#        echo "done"
        lineStr=`head -$INSTALLED_STR $INSTALLRES |tail -1`
        echo "$lineStr $initfile" >> $instpath/Bin/installed.snmp
        lineStr=`head -$INSTALLED_DONE $INSTALLRES |tail -1`
        echo "$lineStr"


        # Link init file in rc dirs.
#        echo_n "Linking $startfile to $initfile ... "
        lineStr=`head -$LINK_FILE_STR $INSTALLRES |tail -1`
        lineStr1=`head -$INSTALL_TO $INSTALLRES |tail -1`
        echo_n "$lineStr $startfile $lineStr1 $initfile ... "


	# sym. link with force for sco
	if [ "$system" = sco -o "$SYSTEM" = SCO ]; then
	    ln -fs $initfile $startfile
	else
	    ln $initfile $startfile
	fi
        check_fatal

#        echo "Linked: $startfile to $initfile" >> $instpath/installed.snmp
#        echo "done"
        lineStr=`head -$LINK_FILE_STR $INSTALLRES |tail -1`
        lineStr1=`head -$INSTALL_TO $INSTALLRES |tail -1`
        echo "$lineStr $startfile $lineStr1 $initfile" >> $instpath/installed.snmp
        lineStr=`head -$INSTALLED_DONE $INSTALLRES |tail -1`
        echo "$lineStr"

#        echo_n "Linking $stopfile to $initfile ... "
        lineStr=`head -$LINK_FILE_STR $INSTALLRES |tail -1`
        lineStr1=`head -$INSTALL_TO $INSTALLRES |tail -1`
        echo_n "$lineStr $stopfile $lineStr1 $initfile ... "

	# sym. link with force for sco
	if [ "$system" = sco -o "$SYSTEM" = SCO ]; then
	    ln -fs $initfile $stopfile
	else
	    ln $initfile $stopfile
	fi
        check_fatal

#        echo "Linked: $stopfile to $initfile" >> $instpath/installed.snmp
#        echo "done"
        lineStr=`head -$LINK_FILE_STR $INSTALLRES |tail -1`
        lineStr1=`head -$INSTALL_TO $INSTALLRES |tail -1`
        echo "$lineStr $stopfile $lineStr1 $initfile" >> $instpath/installed.snmp
        lineStr=`head -$INSTALLED_DONE $INSTALLRES |tail -1`
        echo "$lineStr"
fi

# end-of sysvstartatboot
}

# Common/shared procedures end here
check_ls3 () {

        pidargs=-ax                     # BSD sunos
        ps -ax > /dev/null 2>&1
        if [ $? != "0" ]; then
                pidargs=-e              # svr3 svr4
        fi
        # ps $pidargs | grep ls3 | grep -v grep | awk '{ print $9 }' | grep ls3$
		# Above doesn't seem to work.
		# XXX This should work on all systems now.
	if [ $system = "solari" -o $SYSTEM = "SOLARI" ]; then
        	ps $pidargs | awk '{ if ($4 == "PowerMon") exit 1 }'
	else	
        	ps $pidargs | awk '{ if ($4 == "PowerMonitor") exit 1 }'
	fi
	if [ $? = 1 ]; then
		echo
#		echo "Good! LanSafe for Unix Power Monitor daemon PowerMonitor is running."
        lineStr=`head -$PM_RUNNING $INSTALLRES |tail -1`
        echo "$lineStr"
		echo
	else
		echo
#		echo "NOTE! LanSafe for Unix Power Monitor daemon PowerMonitor is not running."
#		echo
#		echo "     LanSafe SNMP agent requires LanSafe power monitor daemon to be running"
#       echo "     in order to communicate with the SNMP daemon snmpd."
#	    echo
#		echo "Please start PowerMonitor manually or reboot your system to get it running "
#		echo "if it was configured to start at boot."

        lineStr=`head -$WARN_PM_NOT_RUN_STR1 $INSTALLRES |tail -1`
        echo "$lineStr"
        echo
        lineStr=`head -$WARN_PM_NOT_RUN_STR2 $INSTALLRES |tail -1`
        echo "     $lineStr"
        lineStr=`head -$WARN_PM_NOT_RUN_STR3 $INSTALLRES |tail -1`
        echo "     $lineStr"
        echo
        lineStr=`head -$WARN_PM_NOT_RUN_STR4 $INSTALLRES |tail -1`
        echo "$lineStr"
        lineStr=`head -$WARN_PM_NOT_RUN_STR5 $INSTALLRES |tail -1`
        echo "$lineStr"
		echo
	fi
}

# Not used anywhere.  No translation.    RF-- 6/25/03
OLD_aix_get_trap_receiver () {

  trap_receiver=""

  echo "Please enter the hostname or IP address of a node that should"
  echo "receive UPS traps from this node. "
  echo
  echo "Node receiving traps is typically a node running network management"
  echo "system."
  echo
  echo "You can later add additional trap receivers by editing LanSafe "
  echo "section in /etc/snmpd.conf file."
  echo
  echo "An example:"
  echo
  echo "    trap	public	hostname_or_IP	1.3.33.x	fe"
  echo
  echo "where x is unique number not found in any other LanSafe trap lines."
  echo
  while [ -z "$trap_receiver" ]; do
    read_def "   Please enter hostname or IP address: "
     host $answer > /dev/null 2>&1
      check_status
          if [ $? != 0 ]; then
                 echo
                 echo "You entered invalid hostname or IP address."
                 trap_receiver=""
          else
                 trap_receiver=$answer
                 #echo "Trap receiver set to: " $trap_receiver
          fi
done

}


compute_hostname_cmd () {
    case "$system" in
	sco)
	    if [ -x /usr/bin/hostname ]; then
		echo /usr/bin/hostname
	    else
		echo hostname
	    fi
	;;
	uw2)
	    if [ -x /usr/ucb/hostname ]; then
		echo /usr/ucb/hostname
	    else
		echo hostname
	    fi
	;;
	aix)
	    if [ -x /usr/bin/hostname ]; then
		echo /usr/bin/hostname
	    else
		echo hostname
	    fi
	;;
	*)
	    echo hostname
	;;
     esac
}

get_hostname () {

if [ "$system" = aix ]; then
    temphostname=`compute_hostname_cmd`

    temphostname2=`host $temphostname`

    echo $temphostname2 | awk '{ print $1 }'
fi
}

# This works only on aix!
# XXX Danger here!
get_IP_address () {

if [ "$system" = aix ]; then
    temphostname=`hostname`
    check_fatal
    temphostname2=`host $temphostname`
    check_fatal

    echo $temphostname2 | awk '{ print $3 }'
fi

}

get_tardev () {
    tardev=""
    while [ -z "$tardev" ]; do
        echo
#        echo "Please enter the name of the tarfile to install from."
#        read_def "   Install device: "

        lineStr=`head -$GET_DEVICE_NAME $INSTALLRES |tail -1`
        echo "$lineStr"
        lineStr=`head -$INSTALL_DEVICE $INSTALLRES |tail -1`
        read_def "    $lineStr "

        if [ -z "$answer" ]; then
            continue
        fi
        if [ '(' -c "$answer" ')' -o '(' -b "$answer" ')' ]; then
            tardev=$answer
        elif [ -d $answer ]; then
#            echo "'$answer' is a invalid because it is a directory?"
            lineStr=`head -$ERR_INVALID_DIR $INSTALLRES |tail -1`
            echo "'$answer' $lineStr"
        elif [ -f $answer ]; then
#            echo "Expecting a device name, but '$answer' is a file?"
            lineStr=`head -$ERR_INVALID_DEVICE_STR1 $INSTALLRES |tail -1`
            lineStr1=`head -$ERR_INVALID_DEVICE_STR2 $INSTALLRES |tail -1`
            echo "$lineStr '$answer' $lineStr1"
            tardev=$answer
#            read_def "   Is this okay? (y/n) [n] " "n"
            lineStr=`head -$OK_STR $INSTALLRES |tail -1`
            read_def "   $lineStr (y/n) [n] " "n"
            case $answer in
            [yY]|[yY][eE][sS])
                tar_install=true
                ;;
            *)
                tardev=""
                ;;
            esac
        else
#            echo "'$answer' does not exist or is not a device?"
            lineStr=`head -$ERR_NO_DEVICE $INSTALLRES |tail -1`
            echo "'$answer' $lineStr"

            # Override is no longer in use.  No translation.  RF-6/25/03
            if [ $override ]; then
                echo "Override set, using '$answer'."
                tardev=$answer
            else
                continue
            fi
        fi
    done
}


get_boot_flag () {
	# Get start at boot flag
	echo
#	echo "Automatic Startup"
#	echo
#	echo "To automatically run LanSafe SNMP agent upon startup on the computer"
#	echo "being installed, enter (y)es, otherwise enter (n)o."
#	echo
#	echo "NOTE: It is strongly recommended that you select Yes for this option"
#	echo "in order to provide complete SNMP management capability."
#	echo
#	read_def "   Automatically run LanSafe SNMP agent on startup? (y/n) [y] " "y"

#    lineStr=`head -$AUTO_START_STR1 $INSTALLRES |tail -1`
#    echo "$lineStr"
#    echo
#    lineStr=`head -$AUTO_START_AGENT_STR1 $INSTALLRES |tail -1`
#    echo "$lineStr"
#    lineStr=`head -$AUTO_START_AGENT_STR2 $INSTALLRES |tail -1`
#    echo "$lineStr"
#    echo
#    lineStr=`head -$AUTO_START_STR4 $INSTALLRES |tail -1`
#    echo "$lineStr"
#    lineStr=`head -$AUTO_START_STR5 $INSTALLRES |tail -1`
#    echo "$lineStr"
#    echo
#    lineStr=`head -$AUTO_START_AGENT_STR3 $INSTALLRES |tail -1`
#	read_def "   $lineStr (y/n) [y] " "y"
#	case $answer in
#	[yY]|[yY][eE][sS])
#		startatboot="yes" ;;
#	*)
#		startatboot="no" ;;
#	esac

    startatboot="yes"
}


echo_config () {
	# Echo configuration and verify
	if [ $# -eq 1 ]; then
                echo
                echo "---------------------------------------------------------------"
#                echo "LanSafe SNMP Agent Installation Parameters:"
#                echo
#                echo "                     Directory to install to is:  $instpath"
#		        echo "Automatically run LanSafe SNMP agent on startup:  $startatboot"

                lineStr=`head -$AGENT_PARAMS_TO_STR1 $INSTALLRES |tail -1`
                echo "$lineStr"
                echo
                lineStr=`head -$AGENT_PARAMS_TO_STR2 $INSTALLRES |tail -1`
                echo "                     $lineStr  $instpath"
                lineStr=`head -$AGENT_PARAMS_TO_STR3 $INSTALLRES |tail -1`
                echo "$lineStr  $startatboot"
                echo "---------------------------------------------------------------"
                echo
    	else
		echo
                echo "---------------------------------------------------------------"
#                echo "LanSafe SNMP Agent Installation Parameters:"
#                echo
#                echo "           Device or tarfile to install from is:  $tardev"
#                echo "                     Directory to install to is:  $instpath"
#                echo "Automatically run LanSafe SNMP agent on startup:  $startatboot"

                lineStr=`head -$AGENT_PARAMS_TO_STR1 $INSTALLRES |tail -1`
                echo "$lineStr"
                echo
                lineStr=`head -$AGENT_PARAMS_TO_STR4 $INSTALLRES |tail -1`
                echo "           $lineStr  $tardev"
                lineStr=`head -$AGENT_PARAMS_TO_STR2 $INSTALLRES |tail -1`
                echo "                     $lineStr  $instpath"
#                lineStr=`head -$AGENT_PARAMS_TO_STR3 $INSTALLRES |tail -1`
#                echo "$lineStr  $startatboot"
                echo "---------------------------------------------------------------"
                echo
	fi
                answer=""
                while [ -z "$answer" ]; do
                    echo
#                    read_def "  Are these installation parameters acceptable? (y/n) "
                    lineStr=`head -$CONFIRM_INSTALL_PARAMS_STR5 $INSTALLRES |tail -1`
                    read_def "  $lineStr (y/n) "
                done
                case $answer in
                [yY]|[yY][eE][sS])
                    userverified=true
                    ;;
		*)
		    userverified=""
		    ;;
                esac
}

extract_files () {
    firsttime=true
    while [ -z "$tardev" -o ! -z "$firsttime" ]; do
	# Prompt for different device name only if extract below fails
	# i.e firsttime=""
	if [ -z "$firsttime" ]; then
	    get_tardev
	fi
	firsttime=""
	case $tardev in
	*f0*|*f1*|*fd*|*floppy*|*dsk*)
	    media=disk
	    # For each disk
	    for disk in `compute_disks`; do
		if [ $disk != "1" ]; then
		    maybe_eject
		    if [ "$system" = "ia" ]; then
			LongName="Interactive"
		    else
			LongName="$system"
		    fi
		    echo
            # Not used any more.  No translation.   RF 6/25/03
		    echo_n "Insert $LongName disk #"$disk "... press Enter when ready. ."
		    read x
		fi
		echo   "Extracting files ..."
		if [ $disk != 1 ]; then
		    tar -xf $tardev ${disk}_${system}_$lang > /dev/null 2>&1
		else
		    tar -xf $tardev ${disk}_install > /dev/null 2>&1
		fi
		check_status
		if [ $? != 0 ]; then
		    echo "Error extracting files?"
		    tardev=
		    continue 2
		fi
	    done
	    maybe_eject
	    ;;
	*st*|*mt*|*)
	    media=tape
	    echo
	    echo   "Extracting files ..."
	    tar -xf $tardev `compute_tapedirs` > /dev/null 2>&1
            check_status
	    if [ $? != 0 ]; then
#		echo "Error extracting files?"
        lineStr=`head -$ERR_EXTRACT_AGENT $INSTALLRES |tail -1`
        echo "$lineStr"
		tardev=
		continue
	    fi
	    ;;
	esac
    done
# end-of extract_files
}

create_path() {
    fullpath=""
    for path in `echo $1 | sed 's/\// /g'`; do
	fullpath=$fullpath/$path
	if [ ! -d $fullpath ]; then
	    mkdir $fullpath
	    if [ $? != 0 ]; then
		return 1
	    fi
	    chmod 755 $fullpath
	    chown bin $fullpath
	    chgrp bin $fullpath
	    if [ $? != 0 ]; then
		return 1
	    fi
	fi
    done
    if [ -d $1 ]; then
	return 0
    fi
    return 1
}

compute_topath () {
    case $1 in
	*)
	  echo $instpath/Bin
    ;;
    esac
}

compute_toperm () {
    case $1 in
	rfc*)
	    echo 0444
	;;
	PowerMonitorAgent|lsagent.sh)
	    echo 0744
	;;
	*)
	    echo 0444
	;;
    esac
}

compute_tapedirs () {
    for disk in `compute_disks`; do
	case $disk in
	1)
#		if [ -n "$cdrom_install" ]; then
#	    		echo_n ${disk}_INSTALL " "
#		else
               	echo_n ${disk}_install " "
#		fi
	    ;;
	*)
#		if [ -n "$cdrom_install" ]; then
#			echo_n ${disk}_${SYSTEM}_$lang " "
#		else
			echo_n ${disk}_${system}_$lang " "
#		fi
	    ;;
	esac
    done
    echo
}

install_to () {
    name=$1
    dst=$2
    perm=$3
    prefix=.
    lc_name=$name

#    if [ -n "$cdrom_install" ]; then
#	name=`Convert_Case $name`
#    else
	name=`Convert_Name $name`
#    fi

#	echo_n "Installing $lc_name to $dst ... "
    lineStr=`head -$INSTALL_FROM $INSTALLRES |tail -1`
    lineStr1=`head -$INSTALL_TO $INSTALLRES |tail -1`
	echo_n "$lineStr $lc_name $lineStr1 $dst ... "
    for subdir in `compute_tapedirs`; do

	   if [ -f $subdir/$name ]; then
	 	  prefix=$subdir
	   fi
	  if [ -f $subdir/$name.z ]; then
	    	  prefix=$subdir
	  fi
	  if [ -f $subdir/$name.Z ]; then
	    	  prefix=$subdir
	  fi
     done

#src=$subdir/$name

src=$prefix/$name

    create_path $dst
    check_fatal

    if [ ! -f $src ]; then
	if [ -f $src.z ]; then
	    $uncompress_cmd $src.z
	    check_fatal
	fi
	if [ -f $src.Z ]; then
		if [ -n "$cdrom_install" ]; then
			cp $src.Z /tmp/$name.Z
			$uncompress_cmd /tmp/$name.Z
			src=/tmp/$name
	   	else
	    		$uncompress_cmd $src.Z
		fi
	    check_fatal
	fi
    fi

    rm -f $dst/$lc_name
    if [ -f $dst/$lc_name ]; then
	mv -f $dst/$lc_name $dst/$lc_name~ > /dev/null 2>&1
    fi

     if [ -n "$cdrom_install" ]; then
		cp $src $dst/$lc_name
		check_fatal
     else
 	mv -f $src $dst/$lc_name >/dev/null 2>&1

    	if [ $? != "0" ]; then
                cp $src $dst/$lc_name
		check_fatal
		rm -f $src
    	fi
    fi

    chmod $perm $dst/$lc_name
    check_fatal
    chown bin $dst/$lc_name
    chgrp bin $dst/$lc_name
#    echo "Installed: $dst/$lc_name" >> $instpath/Bin/installed.snmp
#    echo "done"

    lineStr=`head -$INSTALLED_STR $INSTALLRES |tail -1`
    echo "$lineStr $dst/$lc_name" >> $instpath/Bin/installed.snmp
    lineStr=`head -$INSTALLED_DONE $INSTALLRES |tail -1`
    echo "$lineStr"


# end-of install_to
}


install_files () {
    echo
    rm -f $instpath/installed.snmp
    uncompress_cmd=`compute_uncompress`

     for f in `compute_files`; do
	#topath=$instpath/Bin
	topath=`compute_topath $f`
	toperm=`compute_toperm $f`

	    case $f in
		*.tar)
		    untar_to $f $topath $toperm
		    ;;
		*)
		    install_to $f $topath $toperm
		    ;;
	     esac
     done
}

Get_custompath () {
     custompath=""
             while [ -z "$custompath" ]; do
                echo
#                echo "Please enter the absolute custom path where LanSafe for Unix is installed."
#                echo
#                read_def "   Enter absolute path: "
                lineStr=`head -$AGENT_CUSTOM_PATH_STR1 $INSTALLRES |tail -1`
                echo "$lineStr"
                lineStr=`head -$AGENT_CUSTOM_PATH_STR2 $INSTALLRES |tail -1`
                read_def "   $lineStr "
                enteredpath=$answer
                     case $enteredpath in
                        /*)
                             if [ '(' -c "$enteredpath" ')' -o '(' -b "$enteredpath" ')' -o '(' -f "$enteredpath" ')' ]; then
				                echo
#                                echo "'$enteredpath' is a invalid because it is not a directory?"
                                lineStr=`head -$ERR_INVALID_DIR $INSTALLRES |tail -1`
                                echo "'$enteredpath' $lineStr"
                                custompath=""
		             elif [ -d $enteredpath -a ! -f $enteredpath/Bin/PowerMonitor ]; then
			 	echo
#				echo "$enteredpath exists, but there is no LanSafe power monitor PowerMonitor executable."
#				read_def "   Is this okay? (y/n) [n] " "n"

                lineStr=`head -$ERR_NO_PM_EXE $INSTALLRES |tail -1`
                echo "$enteredpath $lineStr"
                lineStr=`head -$OK_STR $INSTALLRES |tail -1`
                read_def "   $lineStr (y/n) [n] " "n"

					 case $answer in
				            [yY]|[yY][eE][sS])
						custompath=$enteredpath
                				;;
				            *)
				                custompath=""
				                ;;
			                 esac
			     else
				if [ ! -d $enteredpath ]; then
				   echo
#  				   echo "$enteredpath does not exist."
                   lineStr=`head -$ERR_SERVICES_FILE_STR2 $INSTALLRES |tail -1`
                   echo "$enteredpath $lineStr"
				   custompath=""
				else
                                   custompath=$enteredpath
 				fi
                             fi
                        ;;
                        *)
                           echo
                           echo "You must enter absolute path to LanSafe install directory."
                           lineStr=`head -$ERR_ABS_PATH $INSTALLRES |tail -1`
                           echo "$lineStr"
                           custompath=""
                        ;;
                     esac
            done
}

get_parameters() {
    case $1 in
    English)
        lang=EN
        ;;
    Japanese)
        lang=JP
        ;;
    *.tar)
        tardev=$1
        ;;
    CD_ROM)
        tardev=$1
        ;;
    Linux)
        SYSTEM=$1
        ;;
    HPUX)
        SYSTEM=$1
        ;;
    AIX4)
        SYSTEM=$1
        ;;
    AIX5)
        SYSTEM=AIX4
        ;;
    Network)
	connectType=$1
	;;
    Serial)
	connectType=$1
	;;
    *)
        instpath=$1
        ;;
    esac
    
}

check_locale_language() {

    set `locale` >/dev/null 2>&1
    case $1 in
    LANG=en_US)
        lang=EN
        ;;
    LANG=C)
        lang=EN
        ;;
    esac
}


# main
main () {

# Must check parameters
    lang=""
	if [ "$param1" != "" ] ; then
        get_parameters $param1
    fi

	if [ "$param2" != "" ] ; then
        get_parameters $param2
    fi

	if [ "$param3" != "" ] ; then
        get_parameters $param3
    fi
	if [ "$param4" != "" ]; then
		get_parameters $param4
	fi

   	compute_SYSTEM
	compute_system

    if [ -z "$lang" ]; then
        check_locale_language
        if [ -z "$lang" ]; then
            lang=EN
        fi
    fi

    if [ -z "$connectType" ]; then
	connectType="Serial"
    fi

   if [ -f "$instpath"/Bin/Network.txt ]; then
        connectType="Network"
   else
	connectType="Serial"
   fi
 
# Initialize defines
    systemdir=2_${system}_$lang
	INSTALLRES=2_${system}_$lang/install.res
    if [ "$tardev" != "CD_ROM" -o "$tardev" != "" ]; then
	    tar -xf $tardev $INSTALLRES >/dev/null 2>&1
     fi
	initDefines

	# Need to know if we are on sco3 or sco5 at this point.
	if [ "$system" = sco -o "$SYSTEM" = SCO ]; then
		sco_system=`compute_sco_system`
	fi

	# ls3agent is not available for these systems:
	#  aix3, dec, interactive, linux, sunos, svr4 and sco3
	if [ '(' "$system" = aix3 ')' -o '(' "$system" = dec ')' -o '(' "$system" = ia ')' -o '(' "$system" = linux ')' \
		-o '(' "$system" = sunos ')' -o '(' "$system" = svr4 ')' -o '(' "$SYSTEM" = AIX3 ')' -o '(' "$SYSTEM" = DEC ')' \
		-o '(' "$SYSTEM" = IA ')' -o '(' "$SYSTEM" = LINUX ')' -o '(' "$SYSTEM" = SUNOS ')' -o '(' "$SYSTEM" = SVR4 ')' \
		-o '(' x$sco_system = xsco3 ')' ];
	then
		echo
#		echo "LanSafe III SNMP agent is not available for this system.."
#		echo "Cannot continue agent.sh execution."
        lineStr=`head -$ERR_AGENT_SYS_STR1 $INSTALLRES |tail -1`
        echo "$lineStr"
        lineStr=`head -$ERR_AGENT_SYS_STR2 $INSTALLRES |tail -1`
        echo "$lineStr"
		exit 0
	fi


	if [ "$system" = aix ]; then
#		this_node_name=`get_hostname`
#		this_node_ip=`get_IP_address`
		zero_ip=0.0.0.0
	fi

# Need to find out if it is HP 9.x or HP 10.x
	if [ "$system" = hpux ]; then
		hp_system=`compute_hpux_system`
	fi

# Set $1 to be the tardev specifed by user in install.sh
#	if [ $# -eq 1 ]; then

#		if [ "$tardev" = CD_ROM ]; then
#			skip_extract=true
#			skip_gettardev=tar
#		elif [ -c "$tardev" -o -b "$tardev" ]; then
#			skip_gettardev=tar
#		elif [ -f ./"$tardev" ]; then
##			tar installation
#			tar_install=true
#			skip_gettardev=tar
#		else
#			echo "$tardev: not a device name."
#            lineStr=`head -$ERR_NOT_DEVICE_NAME $INSTALLRES |tail -1`
#           echo "$tardev: $lineStr"
#			exit 0
#		fi
#	fi

# If two parameters
#	if [ x"$two_parameters" = xtrue ]; then

		if [ "$tardev" = CD_ROM ]; then
			cdrom_install=true
			skip_extract=true
			skip_gettardev=tar
			skip_cleanup=true
		elif [ -c "$tardev" -o -b "$tardev" ]; then
			skip_gettardev=tar
		elif [ -f ./"$tardev" ]; then
			# tar installtion
			tar_install=true
			skip_gettardev=tar
        elif [ "$tardev" = "" ]; then
            echo "Usage: ./agent.sh [language] [tarfile name] [path to install] [UPS connection type] "
#            lineStr=`head -$AGENT_USAGE_STR $INSTALLRES |tail -1`
#            echo "$lineStr"
            exit 0
        else
#			echo "$tardev: not a device name."
            lineStr=`head -$ERR_NOT_DEVICE_NAME $INSTALLRES |tail -1`
            echo "$tardev: $lineStr"
			exit 0
		fi

#        if [ -z "$lang" ]; then
#            check_locale_language
#            if [ -z "$lang" ]; then
#                lang=EN
#            fi
#        fi

        if [ ! -z "$instpath" ]; then
		    if [ -d "$instpath" ]; then
			    skip_instpath=true
		    else
			    echo "$instpath: No such directory."
                lineStr=`head -$ERR_NO_DIR $INSTALLRES |tail -1`
                echo "$instpath: $lineStr"
			    exit 0
		    fi
        fi
#	fi


# Say hello
# If agent.sh is directly called from install.sh with two parameters then do not display this banner.

	if [ x"$two_parameters" != xtrue ]; then

		echo
#		echo   "           Welcome to LanSafe SNMP Agent!"
#		echo   "                Version 5.1.0"
#		echo
#		echo   "To install LanSafe SNMP agent, press <ENTER>"
#		echo   "and fill in the configuration items as they are presented to you."
#		echo
#		echo   "NOTE that in order to run LanSafe SNMP agent you need to"
#		echo   "have LanSafe for Unix already installed in your system."

        lineStr=`head -$AGENT_WELCOME_STR1 $INSTALLRES |tail -1`
        echo "$lineStr"
        lineStr=`head -$AGENT_WELCOME_STR2 $INSTALLRES |tail -1`
        echo "$lineStr"
        echo
        lineStr=`head -$AGENT_WELCOME_STR3 $INSTALLRES |tail -1`
        echo "$lineStr"
        lineStr=`head -$AGENT_WELCOME_STR4 $INSTALLRES |tail -1`
        echo "$lineStr"
        echo
        lineStr=`head -$AGENT_WELCOME_STR5 $INSTALLRES |tail -1`
        echo "$lineStr"
        lineStr=`head -$AGENT_WELCOME_STR6 $INSTALLRES |tail -1`
        echo "$lineStr"
		echo

		if [ ! x"$two_parameters" = xtrue ]; then
#		echo   "This installation script will later prompt you to enter the directory"
#		echo   "in which LanSafe for Unix was installed unless PowerMonitor is not found."
        lineStr=`head -$AGENT_WELCOME_STR7 $INSTALLRES |tail -1`
        echo "$lineStr"
        lineStr=`head -$AGENT_WELCOME_STR8 $INSTALLRES |tail -1`
        echo "$lineStr"
		fi

		echo
#		read_def "  Continue installation? (y/n) [y] " "y"
        lineStr=`head -$CONTINUE_INSTALLATION $INSTALLRES |tail -1`
		read_def "  $lineStr (y/n) [y] " "y"
		case $answer in
		[yY]|[yY][eE][sS])
			;;
		*)
			exit 0
			;;
		esac
	fi

	bsdecho=`compute_echo`

# Check first if snmpd is running

	snmpd_running=""

	if [ "$system" = aix ]; then
		aix_check_snmpd
	fi

	if [ "$system" = hpux ]; then
		hpux_check_extended_agent
	fi

	if [ "$hp_system" = hpux9 ]; then
		hpux_check_for_dfix1350
	fi

	if [ "$system" = sco ]; then
		sco5_check_snmpd
	fi

	if [ "$system" = uw2 ]; then
		uw2_check_snmpd
	fi

	if [ "$system" = solari ]; then
		solaris_check_extended_agent
	fi


	if [ '(' "$system" = hpux ')' -o '(' "$system" = solari ')' -o '(' "$SYSTEM" = HPUX ')' -o '(' "$SYSTEM" = SOLARI ')' ]; then
		echo

	elif [ -n "$snmpd_running" ]; then
		echo
#		echo "Good! SNMP daemon snmpd is running on this node."
#        lineStr=`head -$SNMP_DEAMON_RUNNING $INSTALLRES |tail -1`
#        echo "$lineStr"
		echo
	else
		echo
#		echo "WARNING! SNMP daemon snmpd is not running on this node."
#		echo "SNMP daemon must be running in order to use the LanSafe"
#		echo "SNMP agent."
#		echo "Please consult your system's documentation for instructions"
#		echo "on installing and running the SNMP daemon."

        lineStr=`head -$ERR_SNMP_DEAMON_NOT_RUN_STR1 $INSTALLRES |tail -1`
        echo "$lineStr"
        lineStr=`head -$ERR_SNMP_DEAMON_NOT_RUN_STR2 $INSTALLRES |tail -1`
        echo "$lineStr"
        lineStr=`head -$ERR_SNMP_DEAMON_NOT_RUN_STR3 $INSTALLRES |tail -1`
        echo "$lineStr"
        lineStr=`head -$ERR_SNMP_DEAMON_NOT_RUN_STR4 $INSTALLRES |tail -1`
        echo "$lineStr"
        lineStr=`head -$ERR_SNMP_DEAMON_NOT_RUN_STR5 $INSTALLRES |tail -1`
        echo "$lineStr"

	fi


	if [ "$system" = aix ]; then
		# Check if sysmand is running
		#sysmand_running=""
		#aix_check_sysmand
		# check if there are lines for Systems Monitor in
		# /etc/snmpd.conf

		#SLM_installed=""
		#aix_check_systems_monitor

  # Determine if trap line is needed in /etc/snmpd.conf
  # See function setup_snmpd_conf
  # It is NOT needed if sysmand is running OR
  # SLM line are found on /etc/snmpd.conf
  # We do not add trap receivers anymore.
  #if [ -n "$sysmand_running" -o -n "$SLM_installed" ]; then
  #  trap_line_needed=""
  #else
  #  trap_line_needed=true
  #fi

  # Check if NetView for AIX GUI is running
  netview_running=""

#  if [ "$system" = aix4 ]; then
#    aix_check_netview
#  fi

#  if [ -n "$netview_running" ]; then
#    echo
#    echo "NetView for AIX GUI is running."
#  fi

#  aix_get_trap_receiver

fi

        #       Is the installation from a cd-rom?
        #       if the name of this file is in CAPITAL letters
        #       then it is on a CD-ROM.
        CD_Script=AGENT.SH
        if [ -f ./AGENT.SH ]; then
                cdrom_install=true
                skip_extract=true
                skip_gettardev=tar
                skip_cleanup=true
                tardev=CD_ROM
                compute_SYSTEM
        fi


  #       Kill the ls3agent if it is running so the copy during
  #       installation will run OK
  kill_ls3agent

# XXX
# tardev and instpath were provided from install.sh where
# agent.sh was called as
# agent.sh $tardev $instpath
if [ ! -z "$skip_tardev" -a ! -z "$skip_instpath" ]; then
	if [ -z "$skip_extract" ]; then
	    extract_files
        fi
	install_files
	if [ -z "$skip_cleanup" ]; then
                   rm -rf `compute_tapedirs`
                   rm -f agent.sh
        fi
	#exit 0
fi

    if [ '(' x"$two_parameters" = xtrue ')' -a '(' -d "$instpath" ')' -a '(' -f "$instpath"/Bin/PowerMonitor ')' ]; then
          echo
#          echo "LanSafe SNMP agent will be installed in the same directory ($instpath) "
#          echo "as LanSafe for Unix."
          lineStr=`head -$AGENT_SAME_DIR_STR1 $INSTALLRES |tail -1`
          echo "$lineStr"
          lineStr=`head -$AGENT_SAME_DIR_STR2 $INSTALLRES |tail -1`
          echo "$lineStr ($instpath)"
          echo
                if [ -z "$skip_gettardev" ]; then
                    get_tardev
                fi
                get_boot_flag
                if [ -z "$skip_extract" ]; then
                      extract_files
                fi
                install_files
     elif [ -d /usr/Powerware/LanSafe -a -f /usr/Powerware/LanSafe/Bin/PowerMonitor ]; then
           echo
#           echo "LanSafe for Unix installation has been detected in the "
#           echo "directory /usr/Powerware/LanSafe."
           lineStr=`head -$AGENT_FOUND_DEF_PATH_STR1 $INSTALLRES |tail -1`
           echo "$lineStr"
           lineStr=`head -$AGENT_FOUND_DEF_PATH_STR2 $INSTALLRES |tail -1`
           echo "$lineStr"
           echo
#   	       echo "LanSafe SNMP agent must be installed in the same directory"
#           echo "as LanSafe for Unix."
          lineStr=`head -$AGENT_SAME_DIR_STR1 $INSTALLRES |tail -1`
          echo "$lineStr ($instpath)"
          lineStr=`head -$AGENT_SAME_DIR_STR2 $INSTALLRES |tail -1`
          echo "$lineStr"
           echo
		instpath=/usr/Powerware/LanSafe
		if [ -z "$skip_gettardev" ]; then
                        get_tardev
                fi
		get_boot_flag
		if [ -z "$skip_extract" ]; then
                   extract_files
                fi
		install_files
else
   echo
#   echo "Could not find LanSafe for Unix installation in the standard installation"
#   echo "directory /usr/Powerware/LanSafe."
   lineStr=`head -$WARN_NO_DEF_PATH_STR1 $INSTALLRES |tail -1`
   echo "$lineStr"
   lineStr=`head -$WARN_NO_DEF_PATH_STR2 $INSTALLRES |tail -1`
   echo "$lineStr"
   echo
#   read_def " Do you want to continue LanSafe SNMP agent installation by specifying your custom LanSafe for Unix installation directory? (y/n) [y] " "y"
   lineStr=`head -$AGENT_CUSTOM_PATH $INSTALLRES |tail -1`
   read_def " $lineStr (y/n) [y] " "y"

     case $answer in
            [yY]|[yY][eE][sS])
		Get_custompath
                instpath=$custompath
                userverified=""
                     while [ -z "$userverified" ]; do
                         if [ -z "$skip_gettardev" ]; then
                             get_tardev
                         fi
                         if [ -z "$instpath" ]; then
                             Get_custompath
                             instpath=$custompath
                         fi
                       get_boot_flag
                       echo_config
                         if [ -z "$userverified" ]; then
                             instpath=""
                             skip_gettardev=""
                         fi
                     done
                         if [ -z "$skip_extract" ]; then
                             extract_files
                         fi
                install_files
                ;;
            *)
		if [ -z "$skip_cleanup" ]; then
                   rm -rf 1_install $systemdir
                   rm -f agent.sh
                fi
		exit 0
                ;;
     esac


fi

# Check if ls3 daemon is running

check_ls3


if [ "$system" = aix -o "$SYSTEM" = AIX ]; then
# Setup /etc/snmpd.conf, /etc/snmpd.peers and /etc/mib.defs.
  aix_setup_snmpd_conf
  check_fatal

  if [ -f /etc/snmpdv3.conf ]; then
  	aix_setup_snmpdv3_conf
  	check_fatal
  fi

  aix_setup_snmpd_peers
  check_fatal

  aix_setup_mib_defs
  check_fatal

#  aix_refresh_netview
#  check_fatal

fi


if [ "$system" = hpux ]; then
# extensible subagent files on hpux:
# hp 9.x: /etc/snmpd.extend
# hp 10.x: /etc/SnmpAgent.d/snmpd.extend
  hpux_get_extend_file
  check_fatal

  if [ "$hp_system" = hpux9 ];then
    hpux9_agentversion=`hpux_check_for_agentversion`
  else
    hpux9_agentversion=""
  fi

  hpux_setup_extend_file
  check_fatal
# Setup auto start on boot
    case $hp_system in

       hpux10)
	   hpux10_startatboot
	   ;;
       hpux9)
	   # nul
	   #hpux9_startatboot
	   ;;
    esac
# end-of system = hpux
fi

# Now ls3.sh takes care of starting ls3agent too.
#if [ "$system" = aix4 ]; then
#  aix_inittab_startatboot
#fi


if [ "$system" = sco ]; then
    sco5_setup_snmpd_peers
fi

if [ "$system" = uw2 ]; then
    uw2_setup_snmpd_peers
fi

if [ "$system" = solari ]; then
    solaris_setup_extend_file
fi


if [ "$system" = uw2 -o "$system" = sco -o "$system" = solari ]; then
    sysv_startatboot
fi

if [ "$connectType" = Network ]; then
	mv $instpath/Bin/PowerMonitorAgent $instpath/Bin/PowerMonitorAgent.disabled
fi

    echo
    echo "---------------------------------------------------------------------------"
#    echo "     LanSafe SNMP Agent was successfully installed on your system.     "
    lineStr=`head -$AGENT_SUCCESS_INSTALLED $INSTALLRES |tail -1`
    echo "$lineStr"
    echo "---------------------------------------------------------------------------"
    
    echo
    echo
#   echo "Registration:"
    lineStr=`head -$REGISTRATION_STR1 $INSTALLRES |tail -1`
    echo "$lineStr"
    echo 
#   read_def "Would you like to register LanSafe now? (y/n) [y]" "y"
    lineStr=`head -$REGISTRATION_STR2 $INSTALLRES |tail -1`
    read_def "$lineStr (y/n) [y]" "y"

    case $answer in
    [yY]|[yY][eE][sS])
        lineStr=`head -$WARN_WEB_BROWSER $INSTALLRES |tail -1`
        echo "$lineStr"
        exec netscape "http://www.powerware.com/Products/Software/reg_form.asp" &
	echo
#	echo "Web browser may take a few seconds to start."
        lineStr=`head -$REGISTER_WEBSITE $INSTALLRES |tail -1`
        echo "$lineStr"
	    ;;
    *)
        lineStr=`head -$REGISTER_WEBSITE $INSTALLRES |tail -1`
        echo "$lineStr"
        ;;       
    esac

    # Clean up
    if [ -z "$skip_cleanup" ]; then
        rm -rf `compute_tapedirs`
	    rm -f install.sh
        rm -f agent.sh
    fi

    if [ -f "$instpath"/Bin/Network.txt ]; then
        rm -f "$instpath"/Bin/Network.txt
    fi

}

# Check command line parameters
# This code segment must be out of main() in order to work.
# If this script is called from install.sh:
# $1 has the value of tar device
# $2 has the value of instpath

if [ $# -gt 3 ]; then
	echo "Invalid number of command line parameters."
#    lineStr=`head -$ERR_INVALID_ARGUMENTS $INSTALLRES |tail -1`
#    echo "$lineStr"
	exit 0
fi

if [ $# -le 3 ]; then
	two_parameters=true
else
	two_parameters=""
fi

#tardev="$1"
#instpath="$2"
#main $tardev $instpath

if [ "$1" != "" ]; then
    param1="$1"
fi
if [ "$2" != "" ]; then
    param2="$2"
fi
if [ "$3" != "" ]; then
    param3="$3"
fi

main $param1 $param2 $param3
